package com.chinacreator.access.controller;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.ChannelInfo;
import com.chinacreator.access.exception.BusinessException;
import com.chinacreator.access.restrain.ReqEnum;
import com.chinacreator.access.service.ChannelInfoService;
import com.chinacreator.access.service.CivilizedService;
import com.chinacreator.access.service.UsermobService;
import com.chinacreator.access.util.DateUtil;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.lock.redisson.annotation.DistributedLock;
import com.chinacreator.order.util.DesUtilTo32;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

/**
 * 文明办APP免流产品订购
 */
@RestController
@RequestMapping("/civilize")
public class CivilizedController {

    private static final Logger LOGGER = LoggerFactory.getLogger(CivilizedController.class);

    private UsermobService usermobService;

    private CivilizedService civilizedService;

    @Autowired
    private ChannelInfoService channelInfoService;

    @Autowired
    public void setUsermobService(UsermobService usermobService) {
        this.usermobService = usermobService;
    }

    @Autowired
    public void setCivilizedService(CivilizedService civilizedService) {
        this.civilizedService = civilizedService;
    }

//    @DistributedLock(param = "usermob")
    @DistributedLock(value = "usermob")
    @RequestMapping(value = "/order", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String order(HttpServletRequest request, HttpServletResponse response) {

        String result;
        JSONObject data = TransUtil.reqToAliJSON(request);
//        JSONObject dataCap = new JSONObject();

        try {
//            String userid = data.getString("userid");
            String cpid = Util.fogdec(data.getString("fog"), "cpid");
            String productid = Util.fogdec(data.getString("fog"), "productid");
//            String usermob = usermobService.decodeUserId(userid, cpid);
            LOGGER.info("文明办APP免流产品订购，入参={}，时间={}", data, DateUtil.date2String(new Date(), "yyyyMMdd"));
            String usermob = data.getString("usermob");
            usermob = DesUtilTo32.decode(usermob, DateUtil.date2String(new Date(), "yyyyMMdd"));
            String orderchannel = Util._N_to_10(data.getString("sou"), 32);
            ChannelInfo channelInfo = channelInfoService.findChannelInfo(orderchannel);
            String smschannel = channelInfo == null ? "" : channelInfo.getSmschannel();

            data.put("usermob", usermob);
            data.put("cpid", cpid);
            data.put("productid", productid);
            data.put("channel", data.getString("sou"));
            data.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            data.put("smschannel", smschannel);

            LOGGER.info("文明办APP免流产品订购，入参={}", data);

//            dataCap.put("usermob", data.getString("usermob"));
//            dataCap.put("productid", productid);
//            dataCap.put("channel", data.getString("sou"));

            switch (productid) {
                case "2022120700":
                    result = civilizedService.order(data).toString();
                    break;
                default:
                    throw new BusinessException(ReqEnum.ERROR_Exception_aesutil_decrypt);
            }

        } catch (Exception e) {
            LOGGER.error("文明办APP免流产品订购，入参={}，返回={}", data, e.getMessage());
            e.printStackTrace();

            data = Util.reqAliJsonErr(ReqEnum.ERROR_Exception_system_decrypt);
            return data.toString();
        }
        JSONObject jsonObject = JSONObject.parseObject(result);
        if ("6631".equals(jsonObject.getString("resultCode"))) {
            jsonObject.put("errorInfo", "用户已欠费，请缴费后重新发起！");
        }
        return jsonObject.toString();
    }

}
