package com.chinacreator.access.controller;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.ChannelInfo;
import com.chinacreator.access.service.ChannelInfoService;
import com.chinacreator.access.service.FlowService;
import com.chinacreator.access.service.UsermobService;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 使用（剩余）流量查询
 */
@RestController
@RequestMapping("/flow")
public class FlowController {

    private static final Logger LOGGER = LoggerFactory.getLogger(FlowController.class);

    @Autowired
    private FlowService flowService;

    @Autowired
    private UsermobService usermobService;

    @Autowired
    private ChannelInfoService channelInfoService;

    @RequestMapping(value = "/query", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String query(HttpServletRequest request, HttpServletResponse response) {
        JSONObject result = new JSONObject();

        JSONObject data = TransUtil.reqToAliJSON(request);
        try {
            String userid = data.getString("userid");
            String cpid = Util.fogdec(data.getString("fog"), "cpid");
            String productid = Util.fogdec(data.getString("fog"), "productid");

            String smschannel = "";
            if (data.containsKey("sou")) {
                String orderchannel = Util._N_to_10(data.getString("sou"), 32);
                ChannelInfo channelInfo = channelInfoService.findChannelInfo(orderchannel);
                smschannel = channelInfo == null ? "" : channelInfo.getSmschannel();
            }

            data.put("usermob", usermobService.decodeUserId(userid, cpid));
            data.put("cpid", cpid);
            data.put("productid", productid);
            data.put("smschannel", smschannel);

            LOGGER.info("流量使用查询，入参={}", data);

            return flowService.query(data).toString();
        } catch (Exception e) {
            result.put("resultCode", "8000");
            result.put("resultInfo", "");

            LOGGER.error("流量使用查询失败，入参={}，返回={}", data, e.getMessage());
            e.printStackTrace();
            return result.toString();
        }
    }

}
