package com.chinacreator.access.controller;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.ChannelInfo;
import com.chinacreator.access.bean.RbtMvEntity;
import com.chinacreator.access.restrain.ReqEnum;
import com.chinacreator.access.service.ChannelInfoService;
import com.chinacreator.access.service.RbtMvService;
import com.chinacreator.access.service.UsermobService;
import com.chinacreator.access.service.VideoRbtOrderService;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.order.util.MD5;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 对接沃音乐的试听服务
 * @author jiangtao
 */
@RestController
@RequestMapping("/rbtmv")
public class RbtMvController {

    private static final Logger LOGGER = LoggerFactory.getLogger(RbtMvController.class);

    @Autowired
    private RbtMvService rbtMvService;

    @Autowired
    private VideoRbtOrderService videoRbtOrderService;

    @Autowired
    private UsermobService usermobService;

    @Autowired
    private ChannelInfoService channelInfoService;

    @RequestMapping(value = "/findRbtMvs", method = RequestMethod.POST)
    public String findRbtMvs(HttpServletRequest request) {
        JSONObject requestData = TransUtil.reqToAliJSON(request);
        String productId = Util.fogdec(requestData.getString("fog"), "productid");
        if (requestData.containsKey("productid")) {
            productId = requestData.getString("productid");
        }

        List<Map<String, String>> data = rbtMvService.findRbtMvs(productId);
        Map<String, Object> result = new HashMap<>();
        result.put("resultCode", "0000");
        result.put("resultInfo", "");
        result.put("data", data);
        return JSONObject.toJSONString(result);
    }

    /**
     * 设置视频彩铃
     * @param request
     * @return
     */
    @RequestMapping(value = "/setting", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String setting(HttpServletRequest request) {
        JSONObject data = TransUtil.reqToAliJSON(request);
        JSONObject result;
        try {
            String userid = data.getString("userid");
            String cpid = Util.fogdec(data.getString("fog"), "cpid");
            String productid = Util.fogdec(data.getString("fog"), "productid");
            String usermob = usermobService.decodeUserId(userid, cpid);

            String smschannel = "";
            if (data.containsKey("sou")) {
                String orderchannel = Util._N_to_10(data.getString("sou"), 32);
                ChannelInfo channelInfo = channelInfoService.findChannelInfo(orderchannel);
                smschannel = channelInfo == null ? "" : channelInfo.getSmschannel();
            }

            data.put("usermob", usermob);
            data.put("cpid", cpid);
            data.put("productid", productid);
            data.put("smschannel", smschannel);

            LOGGER.info("设置视频彩铃，入参={}", data);
            result = videoRbtOrderService.setting(data);

        } catch (Exception e) {
            LOGGER.error("设置视频彩铃失败，入参={}，返回={}", data, e.getMessage());
            e.printStackTrace();

            data = Util.reqAliJsonErr(ReqEnum.ERROR_Exception_system_decrypt);
            return data.toString();
        }

        return result.toString();
    }

    /**
     * audition.appkey=3000008249
     * audition.appsecret=99C352FEE12F7509
     * audition.host=https://listen.10155.com/listener/
     * @param args
     */
    public static void main(String[] args) {
        String host = "https://listen.10155.com/listener/";
        String appkey = "3000008249";
        String appsecret = "99C352FEE12F7509";

        RbtMvEntity entity = new RbtMvEntity();
        entity.setContentid("79852000202009026162650");
        entity.setCover("/womusic-bucket/90115000/mv_vod/volteposter/verticalpath/20200902/1300983288176160769.jpg");
        entity.setVideo("/womusic-bucket/90115000/mv_vod/volte_mp4/20200902/1300983283843444738.mp4");

        String timestamp = String.valueOf(System.currentTimeMillis());
        String token = MD5.MD5Encode(appkey + "&SHITING&" + timestamp + "&" + appsecret + "&" + entity.getContentid()).toUpperCase();

        String url = host + entity.getVideo() + "?user=&channelid=" + appkey
                + "&contentid=" + entity.getContentid() + "&tokenid=" + token
                + "&timestamp=" + timestamp;
        System.out.println(url);
        //HttpRequest request = HttpRequest.get(url);
        //String result = new String(request.bytes(), Charset.forName("UTF-8"));

        //System.out.println(result);
    }
}
