package com.chinacreator.access.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.ChannelInfo;
import com.chinacreator.access.service.*;
import com.chinacreator.access.util.DESUtil;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.ecd.wechat.util.StringUtil;
import com.chinacreator.lock.redisson.annotation.DistributedLock;
import com.chinacreator.order.util.AESUtil;
import com.chinacreator.order.util.Util;
import com.mysql.cj.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;


/**
 * 红包组的权益，视频7天会员等
 */
@RestController
@RequestMapping("/rights")
public class RightsController {

    private static final Logger LOGGER = LoggerFactory.getLogger(RightsController.class);

    @Autowired
    private RightsService rightsService;

    @Autowired
    private UsermobService usermobService;

    @Autowired
    private ChannelInfoService channelInfoService;

    private final static String PASSWORD = "E5uIO8bvxR5WGahr";

    // 线程池
    private ExecutorService threadPool = Executors.newCachedThreadPool();

    // 畅视公众号账号
    @Autowired
    private ChangshiPublicAccountService changshiPublicAccountService;

    @RequestMapping(value = "/querys", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String querys(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToAliJSON(request);

        JSONObject result = new JSONObject();

        try {
            String userid = data.getString("userid");
            String cpid = Util.fogdec(data.getString("fog"), "cpid");
            LOGGER.info("查询权益开通记录与状态all，decodeUserId", userid, cpid);
            String usermob = usermobService.decodeUserId(userid, cpid);
            String productid = Util.fogdec(data.getString("fog"), "productid");
//            String orderchannel = Util._N_to_10(data.getString("sou"), 32);

            data.put("productid", productid);

            data.put("vipcode", data.getString("vipcode"));
            data.put("usermob", usermob);

            LOGGER.info("userid=" + userid + "," + "&cpid=" + cpid + "&usermob=" + usermob + "&productid=" + productid);
            String returnStr = rightsService.querys(data).toString();
            LOGGER.info("查询权益开通记录与状态all，入参={}，返回={}", data, returnStr);

            JSONObject jsonObject = JSON.parseObject(returnStr);

            if (jsonObject.containsKey("data")) {
                JSONArray jsonArray = jsonObject.getJSONArray("data");
                for (int i=0; i<jsonArray.size(); i++) {
                    JSONObject item = jsonArray.getJSONObject(i);
                    item.put("spid", AESUtil.encrypt(item.getString("productid"), PASSWORD));
                }
            }
            LOGGER.info("查询权益开通记录与状态all，入参={}2，返回={}", data, returnStr);
            return jsonObject.toJSONString();
        } catch (Exception e) {
            result.put("resultCode", "8000");
            result.put("resultInfo", "");

            LOGGER.info("查询权益开通记录与状态失败all：{}，错误信息={}", data, e.getMessage());
            e.printStackTrace();
        }

        return result.toString();
    }


    /**
     * 查询权益开通记录与状态
     */
    @DistributedLock(value = "userid")
    @RequestMapping(value = "/query", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String query(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToAliJSON(request);

        JSONObject result = new JSONObject();
        try {

            String userid = data.getString("userid");
            String cpid = Util.fogdec(data.getString("fog"), "cpid");
            String usermob = usermobService.decodeUserId(userid, cpid);
            String productid = Util.fogdec(data.getString("fog"), "productid");

            String smschannel = "";
            if (data.containsKey("sou")) {
                String orderchannel = Util._N_to_10(data.getString("sou"), 32);
                ChannelInfo channelInfo = channelInfoService.findChannelInfo(orderchannel);
                smschannel = channelInfo == null ? "" : channelInfo.getSmschannel();
            }

            if (data.containsKey("spid")) {
                productid = AESUtil.decrypt(data.getString("spid"), PASSWORD);
            }

            data.put("productid", productid);
            data.put("vipcode", data.getString("vipcode"));
            data.put("usermob", usermob);
            data.put("smschannel", smschannel);

//            data.put("productid", productid);
            LOGGER.info("userid=" + userid + "," + "&cpid=" + cpid + "&usermob=" + usermob + "&productid=productid");
            String returnStr = rightsService.query(data).toString();

            result = JSONObject.parseObject(returnStr);
            result.put("productid", productid);
            LOGGER.info("查询权益开通记录与状态，入参={}，返回={}", data, returnStr);

            return result.toJSONString();
        } catch (Exception e) {
            result.put("resultCode", "8000");
            result.put("errorInfo", "系统异常");

            LOGGER.error("查询权益开通记录与状态失败：{}，错误信息={}", data, e.getMessage());
            e.printStackTrace();
        }
        return result.toString();
    }

    /**
     * 领取权益
     */
    @DistributedLock(value = "userid")
    @RequestMapping(value = "/draw", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String draw(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToAliJSON(request);
        String productid;

        JSONObject result = new JSONObject();
        try {
            // 从订购页面进入领取时，不需要传产品编码，从领取记录查询页面领取时，需要传产品编码
            if (data.containsKey("spid") && !StringUtils.isNullOrEmpty(data.getString("spid"))) {
                productid = AESUtil.decrypt(data.getString("spid"), PASSWORD);
                data.put("productid", productid);
            }else{
                productid=Util.fogdec(data.getString("fog"), "productid");
                data.put("productid", productid);
            }

            String userid = data.getString("userid");
            String cpid = Util.fogdec(data.getString("fog"), "cpid");
            String usermob = usermobService.decodeUserId(userid, cpid);

            String smschannel = "";
            if (data.containsKey("sou")) {
                String orderchannel = Util._N_to_10(data.getString("sou"), 32);
                ChannelInfo channelInfo = channelInfoService.findChannelInfo(orderchannel);
                smschannel = channelInfo == null ? "" : channelInfo.getSmschannel();
            }

            data.put("usermob", usermob);
            data.put("vipcode", data.getString("vipcode"));
            data.put("vipuser", data.getString("vipuser"));
            data.put("smschannel", smschannel);

            LOGGER.info("领取权益，入参={}", data);

            result = rightsService.draw(data);

            Map<String, String> param = new HashMap<>();
            try {
                if (!data.containsKey("sou")) {
                    param.put("usermob", usermob);
                    param.put("productid", productid);
                    param.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));

                    SimpleDateFormat sdf =new SimpleDateFormat("yyyyMMddHHmmss");
                    if ("0000".equals(result.getString("resultCode"))) {
                        // keyword1|productname,keyword2|orderstatus,keyword3|price,keyword4|starttime
                        param.put("busiid", "ordersuccess");
                        param.put("orderstatus", "成功");
                        param.put("starttime", sdf.format(new Date()));
                    } else {
                        // keyword1|usermob,keyword2|ordertime,keyword3|productname,keyword4|orderstatus,keyword5|remark
                        param.put("busiid", "drawsuccess");
                        param.put("usermob", usermob);
                        param.put("ordertime", sdf.format(new Date()));
                        param.put("orderstatus", "失败");
                        param.put("remark", result.getString("errorInfo"));
                    }

                    threadPool.execute(() -> {
                        try {
                            changshiPublicAccountService.send(param);
                        } catch (Exception e) {
                            throw new RuntimeException(e);
                        }

                        System.out.println("畅视公众号模板消息线程：" + Thread.currentThread().getName());
                    });
                }
            } catch (Exception e) {
                LOGGER.error("发送畅视模板消息失败：{}", e.getMessage());
            }

        } catch (Exception e) {
            result.put("resultCode", "8000");
            result.put("resultInfo", "");

            LOGGER.info("领取权益失败，入参={}，返回={}", data, e.getMessage());
            e.printStackTrace();
        }

        return result.toString();
    }


    public static void main(String[] args) throws Exception {
        JSONObject item = new JSONObject();
        System.out.println(AESUtil.encrypt(item.getString("productid"), PASSWORD));
    }
}
