package com.chinacreator.access.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.DirectedJiyueBean;
import com.chinacreator.access.dao.SyncOrderMapper;
import com.chinacreator.access.util.AESUtil;
import com.chinacreator.access.util.DateUtil;
import com.chinacreator.access.util.IpAddrUtil;
import com.chinacreator.access.util.SerialnumberUtil;
import com.chinacreator.order.bean.DirectedJyOrderBean;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
public class SyncDirectedController {
    @Value("${sync.directed.cpid}")
    private String cpid;
    @Value("${sync.directed.pwd}")
    private String pwd;
    @Autowired
    private SyncOrderMapper syncOrderMapper;

    private static final Logger LOGGER = LoggerFactory.getLogger(SyncDirectedController.class);

    @RequestMapping(value = "/sync/offlineOrderNotify", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String send(HttpServletRequest request, HttpServletResponse response) {
        Map<String,String> outmap=new HashMap<>();
        String instr ="",inmapstr="";
        String ip= IpAddrUtil.getIpAddr(request);
        try {
            instr = getRequestBodyData(request);
            if(ObjectUtils.isEmpty(instr)){
                outmap.put("resultCode", "1002");
                outmap.put("resultInfo", "参数为空！");
                return JSON.toJSONString(outmap);
            }
            JSONObject jsonObject=JSON.parseObject(instr);
            if(jsonObject.get("cpid")==null){
                outmap.put("resultCode", "1003");
                outmap.put("resultInfo", "渠道编码为空！");
                return JSON.toJSONString(outmap);
            }
            if(!cpid.equals(jsonObject.get("cpid"))){
                outmap.put("resultCode", "1004");
                outmap.put("resultInfo", "渠道编码错误！");
                return JSON.toJSONString(outmap);
            }
            inmapstr= AESUtil.decrypt(jsonObject.get("data").toString(),pwd);
            JSONObject inJson=JSON.parseObject(inmapstr);
            String  type = inJson.get("type")==null?"":inJson.get("type").toString();
            String  productid = inJson.get("productid")==null?"":inJson.get("productid").toString();
            String  ordertime = inJson.get("ordertime")==null?"":inJson.get("ordertime").toString();
            String  usermob = inJson.get("usermob")==null?"":inJson.get("usermob").toString();
            String  canceltime = inJson.get("canceltime")==null?"":inJson.get("canceltime").toString();
            String  starttime = inJson.get("starttime")==null?"":inJson.get("starttime").toString();
            String  endtime = inJson.get("endtime")==null?"":inJson.get("endtime").toString();
            String  channel = inJson.get("channel")==null?"":inJson.get("channel").toString();
            String  inmodecode = inJson.get("inmodecode")==null?"":inJson.get("inmodecode").toString();
            String  sourcedeviceid = inJson.get("sourcedeviceid")==null?"":inJson.get("sourcedeviceid").toString();
            String  staffid = inJson.get("staffid")==null?"":inJson.get("staffid").toString();
            String  firstserialid = inJson.get("firstserialid")==null?"":inJson.get("firstserialid").toString();
            String  prmproductid = inJson.get("prmproductid")==null?"":inJson.get("prmproductid").toString();
            String  prmspid = inJson.get("prmspid")==null?"":inJson.get("prmspid").toString();
            DirectedJyOrderBean queryBean=new DirectedJyOrderBean();
            queryBean.setUsermob(usermob);
            queryBean.setProductid(productid);
            DirectedJiyueBean productbean=new DirectedJiyueBean();
            productbean.setProductid(productid);
            List<DirectedJiyueBean> productlist=syncOrderMapper.queryPoductid(productbean);
            if(productlist.size()<=0){
                outmap.put("resultCode", "0000");
                outmap.put("resultInfo", "产品编码不存在！");
                return JSON.toJSONString(outmap);
            }
            List<DirectedJyOrderBean> orderList=syncOrderMapper.queryDirected(queryBean);
            if(orderList.size()>0){
                if("1".equals(type)){
                    if("0".equals(orderList.get(0).getCurstatus())){
                        DirectedJyOrderBean bean=orderList.get(0);
                        bean.setOrderid(orderList.get(0).getOrderid());
                        bean.setCancelchannel(channel);
                        bean.setCanceltime(canceltime);
                        bean.setEfficttime(endtime);
                        syncOrderMapper.updateOrder(bean);
                    }
                }
            }else{
                DirectedJyOrderBean bean=new DirectedJyOrderBean();
                bean.setUsermob(usermob);
                bean.setOrderid( SerialnumberUtil.Getnum(10000000,99999999));
                bean.setProductid(productlist.get(0).getProductid());
                bean.setProductnewid(productlist.get(0).getProductnewid());
                bean.setCurstatus(type);
                bean.setOrderchannel(channel);
                bean.setOrdertime(ordertime);
                if("1".equals(type)) {
                    bean.setCanceltime(canceltime);
                    bean.setCancelchannel(channel);
                }
                syncOrderMapper.insertDirectedOrder(bean);
            }
            outmap.put("resultCode", "0000");
            outmap.put("resultInfo", "成功！");
        }catch (Exception e){
            e.printStackTrace();
            outmap.put("resultCode", "9999");
            outmap.put("resultInfo", "系统错误！");
        }finally {
            LOGGER.info("sync_order|"+ DateUtil.nowtime()+"|"+ip+"|"+instr+"|"+inmapstr+"|"+JSON.toJSONString(outmap));
        }
        return JSON.toJSONString(outmap);
    }

    public static String getRequestBodyData(HttpServletRequest request) throws IOException {
        BufferedReader bufferReader = new BufferedReader(request.getReader());
        StringBuilder sb = new StringBuilder();
        String line = null;
        while ((line = bufferReader.readLine()) != null) {
            sb.append(line);
        }
        return sb.toString();
    }
}
