package com.chinacreator.access.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.service.UsermobService;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.order.util.Util;

@RestController
public class UsermobController {

	private static final Logger LOGGER = LoggerFactory.getLogger(FlowController.class);

	@Autowired
	private UsermobService usermobService;
	
	@RequestMapping(value = "/decodeUserid", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String decodeUserid(HttpServletRequest request, HttpServletResponse response) {
		JSONObject result = new JSONObject();
		result.put("resultCode", "0");
		result.put("resultInfo", "正常");
		
		JSONObject data = TransUtil.reqToAliJSON(request);
        String userid = data.getString("userid");
        String cpid = Util.fogdec(data.getString("fog"), "cpid");
		
        String usermob = "";
        try {
        	usermob = usermobService.decodeUserId(userid, cpid);
        	result.put("usermob", usermob);
        } catch (Exception e) {
        	result.put("resultCode", "8000");
    		result.put("resultInfo", "手机号码解码失败");
        }
        
		return result.toJSONString();
	}
	
}
