package com.chinacreator.access.controller;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.service.WeiboMemberService;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.lock.redisson.annotation.DistributedLock;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@RestController
@RequestMapping("/weibo")
public class WeiboController {

    private static final Logger LOGGER = LoggerFactory.getLogger(WeiboController.class);

    @Autowired
    private WeiboMemberService weiboMemberService;

    /**
     * 查询微博用户资料
     */
    @RequestMapping(value = "/query", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String query(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToAliJSON(request);

        JSONObject result = new JSONObject();

        try {
            data.put("code", data.getString("code"));
            LOGGER.info("查询微博用户资料，入参={}", data);

            String returnStr = weiboMemberService.queryWeiboUserShow(data).toString();;

            return returnStr;
        } catch (Exception e) {
            result.put("resultCode", "8000");
            result.put("resultInfo", "");

            LOGGER.error("会员领取状态查询失败：入参={}，返回={}", data, e.getMessage());
            e.printStackTrace();
        }
        return result.toString();
    }

}
