package com.chinacreator.access.filter;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.util.TransUtil;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.IOException;

public class RedisLockFilter implements Filter {
    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
        System.out.println("开始");
    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        ServletRequest requestWrapper = null;
        if (request instanceof HttpServletRequest) {
            requestWrapper = new BodyReaderHttpServletRequestWrapper((HttpServletRequest) request);
        }
        if (requestWrapper == null) {
            chain.doFilter(request, response);
        } else {
//            System.out.println("------------------------------请求报文----------------------------------");
//            System.out.println(getParamsFromRequestBody((HttpServletRequest) requestWrapper));
//            System.out.println("------------------------------请求报文----------------------------------");

            JSONObject data = TransUtil.reqToAliJSON((HttpServletRequest) requestWrapper);
            if (data != null && data.get("userid") != null) {
                requestWrapper.setAttribute("userid", data.getString("userid"));
            }

            if (data != null && data.get("usermob") != null) {
                requestWrapper.setAttribute("usermob", data.getString("usermob"));
            }

            chain.doFilter(requestWrapper, response);
        }
    }
    /* *
     * 获取请求体内容
     * @return
     * @throws IOException
     */

    private String getParamsFromRequestBody(HttpServletRequest request) throws IOException {
        BufferedReader br = null;
        String listString = "";
        try {
            br = request.getReader();

            String str = "";

            while ((str = br.readLine()) != null) {
                listString += str;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return listString;
    }

    @Override
    public void destroy() {
        System.out.println("destroy");
    }
}
