package com.chinacreator.access.service;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.FesMessage;
import com.chinacreator.access.util.HttpClientUtil;
import com.chinacreator.access.util.SignatureUtil;
import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
public class AllowlistDrawService {

    private final static Logger LOGGER = LoggerFactory.getLogger(AllowlistDrawService.class);

    public static HttpSendService send = new HttpSendServicImp();

    @Value("${outOfStock.channel}")
    private String channel;

    @Value("${secret}")
    private String secret;

    @Value("${allowlistdarw.url}")
    private String url;

    @Value("${sendUrl}")
    private String sendUrl;

    @Autowired
    private PartService partService;

    /**
     * 领取抖音币
     *
     * @param data
     * @return
     */
    public JSONObject order(JSONObject data) throws Exception {
        JSONObject param = new JSONObject();
        // 接口分配
        param.put("channel", channel);
        //号码
        param.put("ticket", data.getString("ticket"));
        param.put("diccode", "2022051001"); // 2022051001北分7元8G都应定向后向流量包
        param.put("orderchannel", data.getString("orderchannel"));
        param.put("sign", SignatureUtil.signatureStr(param, secret));

        long startTime = System.currentTimeMillis();
        String result = HttpClientUtil.httpClientOfPost(url, param);

        long endedTime = System.currentTimeMillis();
        LOGGER.info("白名单签约产品领取，入参={}，返回={}，耗时={}s", param, result, (endedTime - startTime)/1000);

        JSONObject jsonObject = JSONObject.parseObject(result);
        //下发成功短信
        try {
            if ("0000".equals(jsonObject.get("resultCode"))) {
                int sou = Integer.valueOf(Util._N_to_10(data.getString("sou"), 32));
                String fescod = Util._N_to_10(data.getString("fes"), 32);

                // 用户在前一天打开页面，获取了getstyle，但是在转钟后才提交请求，那么活动结束，需要新的短信
                FesMessage fes = partService.fesExists(fescod, sou);
                if (fes != null) {
                    data.put("new_fescod", fes.getFescod());
                }

                data.put("usermob", jsonObject.getString("usermob"));
                SendBean sendBean = Util.retSmsBean(data, 0);
                JSONObject jsonObject1 = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));

                LOGGER.info("白名单签约发送订购成功短信，入参={}, 返回={}", data, jsonObject1);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return jsonObject;
    }

//    private static void inowhite(String channel,String key){
//        String url="http://100.0.4.69:3344/activity/ino/receive";
//        Map<String,Object> inmap=new HashMap<>();
//        inmap.put("channel",channel);
//        inmap.put("usermob","18612714515");
//        inmap.put("dicode","2022051001");
//        inmap.put("orderchannel","99");
//        inmap.put("sign",SignatureUtil.signatureStr(inmap,key));
//        try {
//            System.out.println(HttpClientUtil.httpClientOfPost(url, inmap));
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//    }

}
