package com.chinacreator.access.service;

import com.chinacreator.access.bean.CapConfig;
import com.chinacreator.access.dao.CapConfigMapper;
import com.chinacreator.access.task.CapConfigTask;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;

@Service
public class CapConfigService {

    private static List<CapConfig> capConfigList = new ArrayList<>();

    @Autowired
    private CapConfigMapper capConfigMapper;

    @PostConstruct
    public void init() {
        CapConfigTask thread = new CapConfigTask(this);
        new Thread(thread).start();
    }

    public void loadCapConfig() {
        capConfigList = capConfigMapper.findAll();
    }

    public CapConfig findCapConfig(String spcode) {
        if (StringUtils.isEmpty(spcode)) {
            return null;
        }
        
        if (capConfigList == null || capConfigList.size() == 0)  {
        	loadCapConfig();
        }

        for (CapConfig capConfig : capConfigList) {
            if (spcode.equals(capConfig.getSpcode())) {
                return capConfig;
            }
        }

        return null;
    }
}
