package com.chinacreator.access.service;

import com.chinacreator.access.bean.ChannelInfo;
import com.chinacreator.access.bean.CpInfo;
import com.chinacreator.access.dao.ChannelInfoMapper;
import com.chinacreator.access.dao.CpInfoMapper;
import com.chinacreator.access.task.ChannelInfoTask;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;

@Service
public class ChannelInfoService {

    private static List<ChannelInfo> channelInfoList = new ArrayList<>();

    @Autowired
    private ChannelInfoMapper channelInfoMapper;

    @PostConstruct
    public void init() {
        ChannelInfoTask thread = new ChannelInfoTask(this);
        new Thread(thread).start();
    }

    public void loadChannelInfo() {
        channelInfoList = channelInfoMapper.findAll();
    }

    public ChannelInfo findChannelInfo(String cpid) {
        if (StringUtils.isEmpty(cpid)) {
            return null;
        }
        
        if (channelInfoList == null || channelInfoList.size() == 0)  {
            loadChannelInfo();
        }

        for (ChannelInfo channelInfo : channelInfoList) {
            if (cpid.equals(channelInfo.getOrderchannel())) {
                return channelInfo;
            }
        }

        return null;
    }
}
