package com.chinacreator.access.service;

import com.chinacreator.access.bean.CpInfo;
import com.chinacreator.access.dao.CpInfoMapper;
import com.chinacreator.access.task.CpInfoTask;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;

@Service
public class CpInfoService {

    private static List<CpInfo> cpInfoList = new ArrayList<>();

    @Autowired
    private CpInfoMapper cpInfoMapper;

    @PostConstruct
    public void init() {
        CpInfoTask thread = new CpInfoTask(this);
        new Thread(thread).start();
    }

    public void loadCpInfo() {
        cpInfoList = cpInfoMapper.findAll();
    }

    public CpInfo findCpInfo(String cpid) {
        if (StringUtils.isEmpty(cpid)) {
            return null;
        }
        
        if (cpInfoList == null || cpInfoList.size() == 0)  {
        	loadCpInfo();
        }

        for (CpInfo cpInfo : cpInfoList) {
            if (cpid.equals(cpInfo.getCpid())) {
                return cpInfo;
            }
        }

        return null;
    }
}
