package com.chinacreator.access.service;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.util.AESUtil;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
public class FlowService {

    private static final Logger LOGGER = LoggerFactory.getLogger(FlowService.class);

    private static HttpSendServicImp send = new HttpSendServicImp();

    @Value("${sendUrl}")
    private String sendUrl;

    public JSONObject query(JSONObject data) throws Exception {
        String productid = Util.fogdec(data.getString("fog"), "productid");
        SendBean sendBean = Util.retFlowBean(data, productid);
        String cpid = Util.fogdec(data.getString("fog"), "cpid");

        JSONObject result = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));

        if ("0000".equals(result.getString("resultCode"))) {
            String encryptDsta = result.getString("queryflow");
            String decryptData = AESUtil.decrypt(encryptDsta, Util.keyMap.get(cpid));
            JSONObject jsonObject2 = JSONObject.parseObject(decryptData);
            jsonObject2.remove("usermob");
            result.put("data", jsonObject2.toJSONString());
        }

        LOGGER.info("流量使用查询，入参={}，返回={}", data, result);

        return result;
    }

}
