package com.chinacreator.access.service;


import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.util.DESUtil;
import com.chinacreator.access.util.HttpClientUtil;
import com.chinacreator.access.util.SignatureUtil;
import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * 红包组的权益，视频7天会员等
 */
@Service
public class RightsService {

    private static final Logger LOGGER = LoggerFactory.getLogger(RightsService.class);

    public static HttpSendService send = new HttpSendServicImp();

    @Value("${outOfStock.channel}")
    private String channel;

    @Value("${sinaKey}")
    private String key;

    @Value("${rights.secret}")
    private String secret;

    @Value("${rights.draw.url}")
    private String url;

    @Value("${rights.query.url}")
    private String queryUrl;

    @Value("${rights.queryall.url}")
    private String querys;
    private final static String PASSWORD = "E5uIO8bvxR5WGahr";
    /**
     * 领取抖音币
     *
     * @param data
     * @return
     */
    public JSONObject draw(JSONObject data) throws Exception {
        JSONObject param = new JSONObject();
//        String productid;

        // 接口分配
        param.put("channel", channel);
        //号码
        param.put("usermob", data.getString("usermob"));
        if (data.containsKey("productid")) {
            param.put("productid", data.getString("productid"));
        }
        //抖音号
        param.put("vipcode", data.getString("vipcode"));
        param.put("vipuser", data.getString("vipuser"));
        param.put("sign", SignatureUtil.signatureStr(param, secret));

        long startTime = System.currentTimeMillis();
        String result = HttpClientUtil.httpClientOfPost(url, param);

        long endedTime = System.currentTimeMillis();
        LOGGER.info("领取权益，入参={}，返回={}，耗时={}s", param, result, (endedTime - startTime)/1000);

        return JSONObject.parseObject(result);
    }


    /**
     * 查询权益开通记录与状态
     * @param data
     * @return
     * @throws Exception
     */
    public JSONObject query(JSONObject data) throws Exception {
        JSONObject param = new JSONObject();
        // 接口分配
        param.put("channel", channel);
        //号码
        param.put("usermob", data.getString("usermob"));
        if (data.containsKey("productid")) {
            param.put("productid", data.getString("productid"));
        }
        param.put("sign", SignatureUtil.signatureStr(param, secret));

        long startTime = System.currentTimeMillis();
        String result = HttpClientUtil.httpClientOfPost(queryUrl, param);

        long endedTime = System.currentTimeMillis();
        LOGGER.info("查询权益开通记录与状态，入参={}，返回={}，耗时={}s", param, result, (endedTime - startTime)/1000);

        return JSONObject.parseObject(result);
    }

    public JSONObject querys(JSONObject data) throws Exception {
        JSONObject param = new JSONObject();
        // 接口分配
        param.put("channel", channel);
        param.put("vipcode", data.getString("vipcode"));
        //号码
        param.put("usermob", data.getString("usermob"));
        param.put("sign", SignatureUtil.signatureStr(param, secret));
        long startTime = System.currentTimeMillis();
        String result = HttpClientUtil.httpClientOfPost(querys, param);

        long endedTime = System.currentTimeMillis();
        LOGGER.info("查询权益开通记录与状态all，入参={}，返回={}，耗时={}s", param, result, (endedTime - startTime)/1000);

        return JSONObject.parseObject(result);
    }

    public static void main(String[] args) {
        Map<String, Object> signMap = new HashMap<>();
        signMap.put("productid", "62540781");
        signMap.put("usermob", "15673713687");
        signMap.put("vipcode","30001");
        signMap.put("channel","unkc");
        String sd="c734c02708ad1284f0bab81f6e6fd65ab6d840d5";
//System.out.println(signatureStr(sigMap,key:"netease$%j677#s"));
    }

}

