package com.chinacreator.access.service;

import com.alibaba.fastjson.JSON;
import com.chinacreator.access.exception.BusinessException;
import com.chinacreator.access.restrain.ReqEnum;
import com.chinacreator.order.util.Util;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.chinacreator.access.bean.CpInfo;
import com.chinacreator.access.util.DESUtil;

import java.net.URLDecoder;

@Service
public class UsermobService {

    @Autowired
    private CpInfoService cpInfoService;

    /**
     * 根据号码生产伪码，每个伪码20分钟有效
     * @return
     */
    public String encodeUserId(String usermob, String cpid) throws Exception {
        // String timestamp = String.valueOf(System.currentTimeMillis());
        long startTime = System.currentTimeMillis();
        CpInfo cpInfo = cpInfoService.findCpInfo(cpid);
        String userid = DESUtil.encode(usermob + "&" + startTime, cpInfo.getKeypwd());

        return userid;
    }

    /**
     * 将伪码转成手机号码
     * @return
     */
    public String decodeUserId(String pseudo, String cpid) throws Exception {
        //验证参数
        CpInfo cpInfo = cpInfoService.findCpInfo(cpid);
        System.out.println(JSON.toJSONString(cpInfo) + "," + pseudo);
        String code = DESUtil.decode(pseudo, cpInfo.getKeypwd());

        String usermob = code.split("&")[0];
        String startTime = code.split("&")[1];

        return usermob;
    }

    public String decodeUserId(String pseudo, String cpid, String minute) throws Exception {
        //验证参数
        CpInfo cpInfo = cpInfoService.findCpInfo(cpid);
        String code = DESUtil.decode(pseudo, cpInfo.getKeypwd());

        String usermob = code.split("&")[0];
        String startTime = code.split("&")[1];

        if (minute != null && !"".equals(minute)) {
            if (System.currentTimeMillis() > (Long.valueOf(startTime) + Long.valueOf(minute) * 60 * 1000)) {
                throw new BusinessException(ReqEnum.ERROR_EXPIRED);
            }
        }

        return usermob;
    }

    public static void main(String[] args) throws Exception {
        String usermob = "17645149827";
        long expireTime = System.currentTimeMillis() + 1000 * 60 * 20;

        String userid = DESUtil.encode(usermob + "&" + expireTime, "!@baidu#com6iKey");

        System.out.println(userid);

        System.out.println(DESUtil.decode(URLDecoder.decode("nWiESyw40IBsSUv57G0FcSdhpkuFIsKzMPYHxEqstxA="), "!@baidu#com6iKey"));
    }
}
