package com.chinacreator.access.service;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.access.bean.FesMessage;
import com.chinacreator.access.dao.OrderMapper;
import com.chinacreator.access.util.DateUtil;
import com.chinacreator.access.util.SerialnumberUtil;
import com.chinacreator.order.bean.DirectedJyLogBean;
import com.chinacreator.order.bean.DirectedJyOrderBean;
import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

/**
 * 视频彩铃订购接口
 * @author jiangtao
 */
@Service
public class VideoRbtOrderService {
    private final static Logger LOGGER = LoggerFactory.getLogger(WeiboOrderService.class);
    private static final Logger LOGGER_CAP = LoggerFactory.getLogger("LOGGER_CAP");

    public static HttpSendService send = new HttpSendServicImp();

    @Value("${sendUrl}")
    private String sendUrl;

    @Value("${fValueUrl}")
    private String fValueUrl;

    @Value("${secret}")
    private String secret;

    @Autowired
    private PartService partService;

    @Autowired
    private OrderMapper orderMapper;

    public JSONObject order(JSONObject data) {
        JSONObject jsonObject = new JSONObject();

        JSONObject cap = new JSONObject();
        cap.put("cpid", data.getString("cpid"));
        cap.put("productid", data.getString("productid"));
        cap.put("usermob", data.getString("usermob"));

        try {
            SendBean sendBean = Util.retRbtOrderBean(data, 0);
            jsonObject = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));

            LOGGER.info("订购结果，入参={}，返回={}", sendBean, jsonObject);
            JSONObject result = null;
            //下发成功短信
            if ("0000".equals(jsonObject.get("resultCode"))) {
                try {
                    DirectedJyOrderBean directedJyOrderBean = new DirectedJyOrderBean();
                    String orderid = SerialnumberUtil.Getnum(10000000,99999999);
                    directedJyOrderBean.setOrderid(orderid);
                    directedJyOrderBean.setCpid(cap.getString("cpid"));
                    directedJyOrderBean.setBusiid("rbtOrder");
                    directedJyOrderBean.setUsermob(cap.getString("usermob"));
                    directedJyOrderBean.setProductid(cap.getString("productid"));
                    directedJyOrderBean.setOrderchannel(data.getString("orderchannel"));
                    directedJyOrderBean.setCurstatus("0");
                    directedJyOrderBean.setOrdertime(DateUtil.now("yyyy-MM-dd HH:mm:ss.SSS"));
                    orderMapper.insertDirectedJyOrder(directedJyOrderBean);
                }catch (Exception er){
                    er.printStackTrace();
                }

                int sou = Integer.valueOf(Util._N_to_10(data.getString("sou"), 32));
                String fescod = Util._N_to_10(data.getString("fes"), 32);

                // 用户在前一天打开页面，获取了getstyle，但是在转钟后才提交请求，那么活动结束，需要新的短信
                FesMessage fes = partService.fesExists(fescod, sou);
                if (fes != null) {
                    data.put("new_fescod", fes.getFescod());
                }

                sendBean = Util.retSmsBean(data, 0);
                result = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));

                LOGGER.info("发送订购成功短信，入参={}, 返回={}", data, result);
                LOGGER_CAP.info("发送订购成功短信，入参={}, 返回={}", data, result);
            }

            //记录日志表
            try {
                DirectedJyLogBean logBean = new DirectedJyLogBean();
                logBean.setOrderid(SerialnumberUtil.Getnum(10000000,99999999));
                logBean.setCpid(cap.getString("cpid"));
                logBean.setBusiid("rbtOrder");
                logBean.setUsermob(cap.getString("usermob"));
                logBean.setProductid(cap.getString("productid"));
                logBean.setOrderchannel(cap.getString("orderchannel"));
                logBean.setRequestparam(JSONObject.toJSONString(JSONObject.toJSONString(sendBean)));
                logBean.setResponsecode(jsonObject.get("resultCode")==null?"":jsonObject.get("resultCode").toString());
                logBean.setResponseinfo(jsonObject.get("errorInfo")==null?"":jsonObject.get("errorInfo").toString());
                logBean.setRequesttime(DateUtil.now("yyyy-MM-dd HH:mm:ss.SSS"));

                orderMapper.insertDirectedJyLog(logBean);
            }catch (Exception ef){
                ef.printStackTrace();
            }

        } catch (Exception e) {
            jsonObject.put("resultCode", "8000");
            jsonObject.put("errorInfo", "系统忙，请稍候再试");
            LOGGER.error("订购失败，入参={}, 返回={}", data, e.getMessage());
            e.printStackTrace();
        }

        return jsonObject;
    }

    public JSONObject cancel(JSONObject data) {
        JSONObject jsonObject = null;

        try {
            SendBean sendBean = Util.retRbtOrderBean(data, 1);
            LOGGER.info("rbt退订结果，入参={}, 返回={}", sendBean,2);
            jsonObject = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));

            LOGGER.info("退订结果，入参={}, 返回={}", data, jsonObject);

            JSONObject result = null;
            if ("0000".equals(jsonObject.get("resultCode"))) {
                //下发成功短信

                DirectedJyOrderBean directedJyOrderBean = new DirectedJyOrderBean();
                String orderid = SerialnumberUtil.Getnum(10000000,99999999);
                directedJyOrderBean.setOrderid(orderid);
                directedJyOrderBean.setCpid(data.getString("cpid"));
                directedJyOrderBean.setBusiid("rbtCancel");
                directedJyOrderBean.setUsermob(data.getString("usermob"));
                directedJyOrderBean.setProductid(data.getString("productid"));
                directedJyOrderBean.setCancelchannel(data.getString("cancelchannel"));
                directedJyOrderBean.setCanceltime(DateUtil.now("yyyy-MM-dd HH:mm:ss.SSS"));
                directedJyOrderBean.setCurstatus("1");
                try {
                    orderMapper.cancelOrder(directedJyOrderBean);
                }catch (Exception ef){
                    ef.printStackTrace();
                }
                int sou = Integer.valueOf(Util._N_to_10(data.getString("sou"), 32));
                String fescod = Util._N_to_10(data.getString("fes"), 32);

                // 用户在前一天打开页面，获取了getstyle，但是在转钟后才提交请求，那么活动结束，需要新的短信
                FesMessage fes = partService.fesExists(fescod, sou);
                if (fes != null) {
                    data.put("new_fescod", fes.getFescod());
                }

                SendBean sendBean2 = Util.retSmsBean(data, 1);

                result = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean2));

                LOGGER.info("发送退订短信，入参={}, 返回={}", data, result);
//                LOGGER_CAP.info("发送退订短信，入参={}, 返回={}", data, result);
            }

            //记录日志表
            DirectedJyLogBean logBean = new DirectedJyLogBean();
            logBean.setOrderid(SerialnumberUtil.Getnum(10000000,99999999));
            logBean.setCpid(data.getString("cpid"));
            logBean.setBusiid("rbtcancel");
            logBean.setUsermob(data.getString("usermob"));
            logBean.setProductid(data.getString("productid"));
            logBean.setOrderchannel(data.getString("orderchannel"));
            logBean.setRequestparam(JSONObject.toJSONString(sendBean));
            logBean.setResponsecode(jsonObject.get("resultCode")==null?"":jsonObject.get("resultCode").toString());
            logBean.setResponseinfo(jsonObject.get("errorInfo")==null?"":jsonObject.get("errorInfo").toString());
            logBean.setRequesttime(DateUtil.now("yyyy-MM-dd HH:mm:ss.SSS"));
            try {
                orderMapper.insertDirectedJyLog(logBean);
            }catch (Exception ef){
                ef.printStackTrace();
            }
        } catch (Exception e) {
            jsonObject = new JSONObject();

            jsonObject.put("resultCode", "8000");
            jsonObject.put("errorInfo", "系统忙，请稍候再试");

            LOGGER.error("退订失败，入参={}, 返回={}", data, e.getMessage());
            e.printStackTrace();
        }

        return jsonObject;
    }

    public String query(JSONObject data) {
        JSONObject jsonObject = null;

        try {
            SendBean sendBean = Util.retRbtOrderBean(data, 2);
            jsonObject = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));

            LOGGER.info("查询结果，入参={}, 返回={}", data, jsonObject);

            //记录日志表
            DirectedJyLogBean logBean = new DirectedJyLogBean();
            logBean.setOrderid(SerialnumberUtil.Getnum(10000000,99999999));
            logBean.setCpid(data.getString("cpid"));
            logBean.setBusiid("query");
            logBean.setUsermob(data.getString("usermob"));
            logBean.setProductid(data.getString("productid"));
            logBean.setRequestparam(JSONObject.toJSONString(sendBean));
            logBean.setResponsecode(jsonObject.get("resultCode")==null?"":jsonObject.get("resultCode").toString());
            logBean.setResponseinfo(jsonObject.get("errorInfo")==null?"":jsonObject.get("errorInfo").toString());
            logBean.setRequesttime(DateUtil.now("yyyy-MM-dd HH:mm:ss.SSS"));
            try {
                orderMapper.insertDirectedJyLog(logBean);
            }catch (Exception ef){
                ef.printStackTrace();
            }
        } catch (Exception e) {
            jsonObject = new JSONObject();

            jsonObject.put("resultCode", "8000");
            jsonObject.put("errorInfo", "系统忙，请稍候再试");

            LOGGER.error("查询失败，入参={}, 返回={}", data, e.getMessage());
            e.printStackTrace();
        }

        return jsonObject.toString();
    }

    public JSONObject setting(JSONObject data) {
        JSONObject jsonObject = new JSONObject();

        JSONObject cap = new JSONObject();
        cap.put("cpid", data.getString("cpid"));
        cap.put("productid", data.getString("productid"));
        cap.put("usermob", data.getString("usermob"));

        try {
            SendBean sendBean = Util.retRbtOrderBean(data, 3);
            jsonObject = send.sendPost(sendUrl, JSONObject.toJSONString(sendBean));
            LOGGER.info("设置视频彩铃结果，入参={}, 返回={}", data, jsonObject);

        } catch (Exception e) {
            jsonObject.put("resultCode", "8000");
            jsonObject.put("errorInfo", "系统忙，请稍候再试");
            LOGGER.error("设置视频彩铃失败，入参={}, 返回={}", data, e.getMessage());
            e.printStackTrace();
        }

        return jsonObject;
    }
}
