package com.chinacreator.access.servlet;

import com.alibaba.fastjson.JSON;
import com.chinacreator.access.bean.CapConfig;
import com.chinacreator.access.bean.CpInfo;
import com.chinacreator.access.service.CapAllowblockService;
import com.chinacreator.access.service.CapConfigService;
import com.chinacreator.access.service.CpInfoService;
import com.chinacreator.access.service.PartService;
import com.chinacreator.access.util.IpAddrUtil;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.order.util.AESUtil;
import com.chinacreator.order.util.MD5;
import com.chinacreator.order.util.Util;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 * 页面获取
 * 1.页面初始化样式数据
 * 2.页面产品信息
 * 3.加密数据
 *
 * @author YK
 */
@RestController
@RequestMapping("/ini")
public class IniGain {

    private static final Logger LOGGER = LoggerFactory.getLogger(IniGain.class);

    @Autowired
    private PartService partService;

    @Autowired
    private CpInfoService cpInfoService;

    @Autowired
    private CapConfigService capConfigService;

    @Autowired
    private CapAllowblockService capAllowblockService;

//    private String clientid = "CaK84X0EMbYcBdpEQTeL";
//    private String secret = "1rMtIKhuym0gUAYMeEEX";

    /**
     * 获取页面样式
     *
     * @param request 请求Json
     * @return
     */
    @RequestMapping(value = "/getstyle", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    public void getstyle(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToJSON(request);
        TransUtil.resToJSON(response, partService.pageStyle(data));
    }

//    @RequestMapping(value = "/sendsms", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
//    public void token(HttpServletRequest request, HttpServletResponse response) {
//      JSONObject data = TransUtil.reqToJSON(request);
//        if (!StringUtils.isEmpty(data.getString("smstype"))) {
//            switch (data.getString("smstype")) {
//                case "212":
//                case "210":
//                case "209":
//                case "705":
//                    break;
//                default:
//                    System.out.println("异常短信，" + data + IpAddrUtil.getIpAddr(request));
//                    return;
//            }
//        }
//        TransUtil.resToJSON(response, partService.sendVerCode(data));
//    }

    @RequestMapping(value = "/getsou", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    public void getsou(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToJSON(request);
        TransUtil.resToJSON(response, partService.querysou(data));
    }

    @RequestMapping(value = "/awa", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    public void awaW(HttpServletRequest request, HttpServletResponse response) {
        JSONObject data = TransUtil.reqToJSON(request);
        TransUtil.resToJSON(response, partService.award(data));
    }

    /**
     * 生成直接调用统一认证页面参数
     * @return
     */
    @RequestMapping(value = "/clientsecret", method = RequestMethod.GET, produces = "application/json;charset=UTF-8")
    public String genClientSecret(HttpServletRequest req) {
        String prmSpid = req.getParameter("spid");
        if (StringUtils.isEmpty(prmSpid)) {
            prmSpid = "93366";
        }

        String auth = System.currentTimeMillis() / 1000 + "12345";
        Map<String, String> result = new HashMap<>();
        CapConfig config = capConfigService.findCapConfig(prmSpid);

        result.put("client_id", config.getClientid());
        result.put("auth_no", auth);
        result.put("client_secret", MD5.MD5Encode(config.getClientsecret() + auth));

        return JSON.toJSONString(result);
    }

    /**
     * 生成调用统一认证封装页面的参数
     * @param req
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/gensign", method = RequestMethod.POST, produces = "application/json; charset=UTF-8")
    public String genSign(HttpServletRequest req) throws Exception {
        JSONObject params = TransUtil.reqToJSON(req);
        String fog = params.getString("fog");
        String channel = params.getString("channel");

        // 判断refer
        // 获取请求是从哪里来的
        Map<String, String> result = new HashMap<>();

        String cpid = Util.fogdec(fog, "cpid");
        String ip = IpAddrUtil.getIpAddr(req);
        capAllowblockService.checkReferer(cpid, req.getHeader("referer"), ip);

        String remoteIp = IpAddrUtil.getIpAddr(req);
        String userAgent = IpAddrUtil.getUserAgent(req);
        LOGGER.info("查询统一页面认证参数，入参={}，remoteIp:{}，userAgent:{}", params, remoteIp, userAgent);

        String timpstamp = System.currentTimeMillis() + "";
        result.put("timestamp", timpstamp);
        String productid = Util.fogdec(fog, "productid");
        String password = null;
        if (!StringUtils.isEmpty(channel)) {
            //    password = configLoader.getChannelKeys().get(channel);

        } else {
            CpInfo cpInfo = cpInfoService.findCpInfo(cpid);
            password = cpInfo.getKeypwd();
        }

        result.put("sign", MD5.MD5Encode(cpid + timpstamp + password));
        result.put("cpid", cpid);
        result.put("spid", AESUtil.encrypt(productid, password));
        result.put("clienttype", "3");

        LOGGER.info("查询统一页面认证参数，入参=cpid:{},channel={},remoteIp={},userAgent:{}，返回:{}",
                cpid, channel, remoteIp, userAgent, result);

        return JSON.toJSONString(result);
    }

    @RequestMapping(value = "/tb", method = RequestMethod.GET, produces = "application/json;charset=UTF-8")
    public String tb() {
        String tb = Util.gettb();
        Map<String, String> result = new HashMap<>();
        result.put("tb", tb);
        return JSON.toJSONString(result);
    }


}
