package com.chinacreator.access.task;

import com.chinacreator.access.controller.BackController;
import com.chinacreator.access.service.CapAllowblockService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CapAllowblockTask extends Thread {

    private static final Logger LOGGER = LoggerFactory.getLogger(CapAllowblockTask.class);

    private final static int DURATION = 10 * 60 * 1000;

    private CapAllowblockService service;

    public CapAllowblockTask(CapAllowblockService service) {
        this.service = service;
    }

    @Override
    public void run() {

        while (true) {
            try {
                service.loadCapAllowblock();

                LOGGER.info("刷新/缓存CAP白名单完成");
            } catch (Exception e) {
                LOGGER.info("刷新/缓存CAP白名单缓存失败，返回={}", e.getMessage());
                e.printStackTrace();
            } finally {
                try {
                    Thread.sleep(DURATION);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
