package com.chinacreator.access.task;

import com.chinacreator.access.service.ChannelInfoService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ChannelInfoTask extends Thread {

    private static final Logger LOGGER = LoggerFactory.getLogger(ChannelInfoTask.class);

    private final static int DURATION = 10 * 60 * 1000;

    private ChannelInfoService service;

    public ChannelInfoTask(ChannelInfoService service) {
        this.service = service;
    }

    @Override
    public void run() {

        while (true) {
            try {
                service.loadChannelInfo();

                LOGGER.info("刷新/缓存tb_ordercenter_channel完成");
            } catch (Exception e) {
                LOGGER.info("刷新/缓存tb_ordercenter_channel缓存失败，返回={}", e.getMessage());
                e.printStackTrace();
            } finally {
                try {
                    Thread.sleep(DURATION);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
