package com.chinacreator.access.task;

import com.chinacreator.access.dao.MessageDao;
import com.chinacreator.access.service.DxService;
import com.chinacreator.order.util.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.sql.SQLException;

/**
 * @author jiangtao
 */
@Component
public class ClearData {

    private static final Logger LOGGER = LoggerFactory.getLogger(ClearData.class);

    @Autowired
    private MessageDao messagedao;

    @Autowired
    private DxService dxService;

    /**
     * 每天早上2：00触发,短信验证码发送上限表清空
     */
    @Scheduled(cron = "0 0 2 * * ?")
    public void clearCodelim() {
        if ("1".equals(Util.gettb())) {
            try {
                messagedao.Vcodelim();
                LOGGER.info("短信验证码发送次数表清空成功");

            } catch (SQLException e) {

                LOGGER.error("短信验证码发送次数表清空失败，返回={}", e.getMessage());
                e.printStackTrace();
            }
        }
    }

    /**
     * 每天早上1：00触发,短信验证码校验表清空
     */
    @Scheduled(cron = "0 0 1 * * ?")
    public void clearCode() {
        if ("1".equals(Util.gettb())) {
            try {
                messagedao.Vcode();
                LOGGER.info("短信验证码表清空成功");

            } catch (SQLException e) {

                LOGGER.error("短信验证码表清空成功失败，返回={}", e.getMessage());
                e.printStackTrace();
            }
        }
    }

//    @Scheduled(cron = "0 30 4 1,2,3,4,5 * ?")//月1-5日 4:30触发,预约用于订购
//    public void yuyueTask(){
//    	if("1".equals(Util.gettb())){
//	    	try {
//	    		InetAddress add = InetAddress.getLocalHost();
//	    		String host = add.getHostAddress();
//	    		if(host.equals("100.0.3.11")){
//	    			dxService.taskYuyue();
//	    			logger.error("预约定时任务执行");
//	    		}
//			} catch (Exception e) {
//				e.printStackTrace();
//				logger.error("预约定时任务执行失败");
//			}
//    	}
//    }

    /**
     * 月1日 00:10触发,对后项订购清理
     */
    @Scheduled(cron = "0 10 0 1 * ?")
    public void clearInverSionOrder() {
        if ("1".equals(Util.gettb())) {
            try {
                messagedao.InverSionOrder();
                LOGGER.error("对后项订购清理成功");

            } catch (Exception e) {
                LOGGER.error("对后项订购清理失败，返回={}", e.getMessage());
                e.printStackTrace();
            }
        }
    }
}
