package com.chinacreator.access.task;

import com.chinacreator.access.service.CpInfoService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CpInfoTask implements Runnable {

    private static final Logger LOGGER = LoggerFactory.getLogger(CpInfoTask.class);

    private final static int DURATION = 10 * 60 * 1000;

    private CpInfoService service;

    public CpInfoTask(CpInfoService service) {
        this.service = service;
    }

    @Override
    public void run() {

        while (true) {
            try {
                service.loadCpInfo();
                LOGGER.info("刷新/缓存CPINFO完成");
            } catch (Exception e) {
                LOGGER.info("刷新/缓存CPINFO失败");
                e.printStackTrace();
            } finally {
                try {
                    Thread.sleep(DURATION);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }

        }


    }

}
