package com.chinacreator.access.task;

import com.chinacreator.access.service.PartService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class GetStyleTask extends Thread {
    private static final Logger LOGGER = LoggerFactory.getLogger(GetStyleTask.class);
    private final static int DURATION = 10 * 60 * 1000;

    private PartService service;

    public GetStyleTask(PartService service) {
        this.service = service;
    }

    @Override
    public void run() {

        while (true) {
            try {
                service.refreshFestival();
                service.refreshProduct();
                service.refreshFesChan();

                LOGGER.info("刷新/缓存活动配置完成");
            } catch (Exception e) {
                LOGGER.info("刷新/缓存活动配置失败，返回={}", e.getMessage());
                e.printStackTrace();
            } finally {
                try {
                    Thread.sleep(DURATION);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
