package com.chinacreator.access.task;

import com.chinacreator.access.service.RbtMvService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 定时刷新视频彩铃的缓存
 * @author jiangtao
 */
public class RbtMvTask implements Runnable {

    private static final Logger LOGGER = LoggerFactory.getLogger(RbtMvTask.class);

    private final static int DURATION = 10 * 60 * 1000;

    private RbtMvService service;

    public RbtMvTask(RbtMvService service) {
        this.service = service;
    }

    @Override
    public void run() {

        while (true) {
            try {
                service.loadAudition();

                LOGGER.info("刷新/缓存RbtMv白名单完成");
            } catch (Exception e) {
                LOGGER.info("刷新/缓存RbtMv白名单缓存失败，返回={}", e.getMessage());
                e.printStackTrace();
            } finally {
                try {
                    Thread.sleep(DURATION);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
