package com.chinacreator.access.util;

import ch.qos.logback.core.Context;
import ch.qos.logback.core.spi.PropertyDefiner;
import ch.qos.logback.core.status.Status;
import com.alibaba.fastjson.JSON;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.File;
import java.util.*;

/**
 * @author jiangtao
 */
public class GetPortCustomProperty implements PropertyDefiner {

    private static List<Map<String, Object>> list = new ArrayList<>();

    @Override
    public String getPropertyValue() {
        return getTomcatPortValue();
    }

    @Override
    public void setContext(Context context) {

    }

    @Override
    public Context getContext() {
        return null;
    }

    @Override
    public void addStatus(Status status) {

    }

    @Override
    public void addInfo(String msg) {

    }

    @Override
    public void addInfo(String msg, Throwable ex) {

    }

    @Override
    public void addWarn(String msg) {

    }

    @Override
    public void addWarn(String msg, Throwable ex) {

    }

    @Override
    public void addError(String msg) {

    }

    @Override
    public void addError(String msg, Throwable ex) {

    }

    public String getTomcatPortValue() {
        String catalinaHome = System.getProperty("catalina.home");

        System.out.println("开始读取tomcat配置文件home=" + catalinaHome);

        if (StringUtils.isEmpty(catalinaHome)) {
            return StringUtils.EMPTY;
        }

        try {
            String serverXml = catalinaHome + "/conf/server.xml";
            readXML(serverXml);

            System.out.println("解析完成配置文件server=：" + JSON.toJSONString(list));

            for (Map<String, Object> map : list) {
                if (map.containsKey("protocol")
                    &&"HTTP/1.1".equals(map.get("protocol").toString())) {
                    System.out.println("端口号port=" + map.get("port").toString());
                    return map.get("port").toString();
                }
            }
        } catch (Exception e) {
            return StringUtils.EMPTY;
        }

        return StringUtils.EMPTY;
    }

    public static void readXML(String path) throws DocumentException {
        // 创建saxReader对象
        SAXReader reader = new SAXReader();
        // 通过read方法读取一个文件 转换成Document对象
        Document document = reader.read(new File(path));
        //获取根节点元素对象
        Element rootElement = document.getRootElement();
        listNode(rootElement);

        for (Map<String, Object> map : list) {
            System.out.println(JSONObject.fromObject(map));
        }
    }

    public static void listNode(Element node) {
        @SuppressWarnings("unchecked")
        List<Attribute> attrs = node.attributes();
        Map<String, Object> map = new HashMap<>();

        // 遍历属性节点
        for (Attribute attr : attrs) {
            map.put(attr.getName(), attr.getValue());
        }

        if (!"".equals(node.getTextTrim())) {
            map.put(node.getName(), node.getText());
        }

        // 当前节点下面子节点迭代器
        @SuppressWarnings("unchecked")
        Iterator<Element> it = node.elementIterator();
        // 遍历
        while (it.hasNext()) {
            // 获取某个子节点对象
            Element e = it.next();
            // 对子节点进行遍历
            listNode(e);
        }

        list.add(map);
    }
}


