package com.chinacreator.ecd.wechat;

import com.chinacreator.ecd.wechat.util.StringUtil;
import org.apache.commons.codec.digest.DigestUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

/**
 * 设置微信公众号-基本配置-接口配置信息 时使用
 * 服务器返回给微信公众平台token验证开发者是否有自己的服务器
 */
@RestController
public class ServerVerifyController {

    private static String TOKEN = "hello123";

    public static String genUrl() {
        String echostr = StringUtil.getRandomString(12);
        System.out.println("echostr:" + echostr);

        String timestamp = System.currentTimeMillis() + "";
        System.out.println("timestamp:" + timestamp);

        String nonce = "9";
        System.out.println("nonce:" + nonce);

        String[] str = {TOKEN, timestamp, nonce};
        Arrays.sort(str);
        String bigStr = str[0] + str[1] + str[2];

        // SHA1加密
        String signature = DigestUtils.sha1Hex(bigStr);

        System.out.println(signature);

        String result = "echostr=" + echostr + "&timestamp=" + timestamp +
                "&nonce=" + nonce + "&signature=" + signature;
        System.out.println(result);

        return result;
    }

    public static void main(String[] args) {
        System.out.println(ServerVerifyController.genUrl());
    }

    @RequestMapping("/server-token")
    public String token(HttpServletRequest request) {
        // 微信加密签名
        String signature = request.getParameter("signature");

        // 随机字符串
        String echostr = request.getParameter("echostr");

        // 时间戳
        String timestamp = request.getParameter("timestamp");

        // 随机数
        String nonce = request.getParameter("nonce");

        String[] str = {TOKEN, timestamp, nonce};

        // 字典序排序
        Arrays.sort(str);
        String bigStr = str[0] + str[1] + str[2];

        // SHA1加密
        String digest = DigestUtils.sha1Hex(bigStr);

        System.out.println(digest);

        // 确认请求来至微信
        if (digest.equals(signature)) {
            return echostr;
        }

        return "验证失败";
    }

}
