package com.chinacreator.ecd.wechat.service;

import com.alibaba.fastjson.JSON;
import com.chinacreator.ecd.wechat.modal.GlobalAccessToken;
import com.chinacreator.ecd.wechat.util.DateUtil;
import com.chinacreator.ecd.wechat.util.StringUtil;
import com.github.kevinsawicki.http.HttpRequest;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;

/**
 * 接口统一调用access_token
 */
@Service
public class GlobalAccessTokenService {

    @Value("${gtoken.url}")
    private String gtokenUrl;

    private static String accessToken = null;
    private static Long refreshDate = null;

    public String token() {
        return DateUtil.expired(refreshDate, 1) ? refresh() : accessToken;
    }

    /**
     * 刷新access_token
     */
    public String refresh() {
        // private static final String url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid={0}&secret={1}";
        String url = gtokenUrl + "?grant_type=client_credential&appid={0}&secret={1}";

        String reqUrl = StringUtil.parse(url, WechatConfig.appid, WechatConfig.secret);

        System.out.println("请求地址是：" + reqUrl);

        HttpRequest request = HttpRequest.get(reqUrl);

        String result = new String(request.bytes(), StandardCharsets.UTF_8);

        System.out.println("获取global_access_token的结果是：" + result);

        GlobalAccessToken token = JSON.parseObject(result, GlobalAccessToken.class);

        if (token.getErrorcode() == null) {
            accessToken = token.getAccess_token();
            refreshDate = System.currentTimeMillis();
        }

        return token.getAccess_token();
    }


}
