package com.chinacreator.ecd.wechat.service;

import com.chinacreator.ecd.wechat.util.StringUtil;
import com.github.kevinsawicki.http.HttpRequest;
import org.apache.commons.codec.digest.DigestUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;

@Service
public class JsSdkService {

    @Autowired
    private GlobalAccessTokenService globalAccessTokenService;

    public static String sign(String noncestr, String jsapiTicket, Integer timestamp, String url) {
        String template = "jsapi_ticket={0}&noncestr={1}&timestamp={2}&url={3}";

        String data = StringUtil.parse(template, jsapiTicket, noncestr, String.valueOf(timestamp), url);
        System.out.println(data);

        System.out.println("生成的签名字符串是：" + DigestUtils.sha1Hex(data));
        return DigestUtils.sha1Hex(data);
    }

    public static void main(String[] args) {
        sign("", "", 1521616128, "safasf");
    }

    public String obtainJsapiTicket() {
        String url = "https://api.weixin.qq.com/cgi-bin/ticket/getticket?access_token=" + globalAccessTokenService.refresh() + "&type=jsapi";

        HttpRequest request = HttpRequest.get(url);
        String result = new String(request.bytes(), StandardCharsets.UTF_8);

        System.out.println("获取jsapi_ticket是：" + result);

        return result;
    }

}
