package com.chinacreator.ecd.wechat.service;

import com.alibaba.fastjson.JSON;
import com.chinacreator.ecd.wechat.modal.OauthAccessToken;
import com.chinacreator.ecd.wechat.util.StringUtil;
import com.github.kevinsawicki.http.HttpRequest;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestMapping;

import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;

/**
 * 网页授权AccessToken
 */
@Service
public class OauthAccessTokenService {

    private final static String OAUTH_ACCESS_TOKEN_URL = "https://api.weixin.qq.com/sns/oauth2/access_token?appid={0}&secret={1}&code={2}&grant_type=authorization_code";

    @RequestMapping("/oauth-access-token")
    public String token() {
        return "";
    }

    /**
     * 刷新access_token
     */
    public OauthAccessToken refresh(String code) {
        String reqUrl = StringUtil.parse(OAUTH_ACCESS_TOKEN_URL, WechatConfig.appid, WechatConfig.secret, code);

        System.out.println("获取oath_access_token的请求地址是：" + reqUrl);
        HttpRequest request = HttpRequest.get(reqUrl);
        String result = new String(request.bytes(), StandardCharsets.UTF_8);

        //TODO 判断TOKEN是否过期

        System.out.println("获取oath_access_token的结果是：" + result);
        OauthAccessToken token = JSON.parseObject(result, OauthAccessToken.class);

        return token;
    }
}
