package com.chinacreator.ecd.wechat.service;

import com.chinacreator.ecd.wechat.util.StringUtil;
import com.github.kevinsawicki.http.HttpRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestMapping;

import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;

//@RestController
//@RequestMapping("/wechat")
@Service
public class WechatUserService {

    @Autowired
    private GlobalAccessTokenService globalAccessTokenService;

    @Autowired
    private OauthAccessTokenService oauthAccessTokenService;

    @RequestMapping("/signup")
    public String signup(String code) {
        return oauthAccessTokenService.refresh(code).getAccessToken();
    }

    /**
     * 通过公众号获取用户信息，subscribe=0表示没有获取到用户信息
     * <p>
     * 如果用户没有关注，则调用signin方法获取用户信息
     */
    //@RequestMapping("/follow_user")
    public String followUser(String openid) {
        String token = globalAccessTokenService.token();
        String url = "https://api.weixin.qq.com/cgi-bin/user/info?access_token={0}&openid={1}&lang=zh_CN";
        String reqUrl = StringUtil.parse(url, token, openid);

        HttpRequest request = HttpRequest.get(reqUrl);
        String result = new String(request.bytes(), StandardCharsets.UTF_8);
        System.out.println("获取follow_user的结果是：" + result);

        return result;
    }


}
