package com.chinacreator.order.service.imp;

import com.chinacreator.access.util.SerialnumberUtil;
import com.chinacreator.order.bean.DirectedJyLogBean;
import com.chinacreator.order.bean.DirectedJyOrderBean;
import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.bean.SmsBean;
import com.chinacreator.order.dao.imp.QueryDaoImp;
import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.service.OrderService;
import com.chinacreator.order.util.AESUtil;
import com.chinacreator.order.util.Util;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class OrderServiceImp implements OrderService {
    private static final Logger LOGGER = LoggerFactory.getLogger(OrderServiceImp.class);

    public static final String requestUrl = Util.getsendUrl();
    public static HttpSendService send = new HttpSendServicImp();
    public static QueryDaoImp dao = new QueryDaoImp();

    /**
     * 订购
     */
    @Override
    public JSONObject orderApply(JSONObject data) {
        JSONObject orderjson = new JSONObject();
        orderjson.put("busiid", "order");
        orderjson.put("usermob", data.getString("usermob"));
        orderjson.put("productid",
                Util.fogdec(data.getString("fog"), "productid"));
        orderjson.put("useraccount", data.getString("useraccount"));
        // 默认订购0线上订购
        orderjson.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        JSONObject fond = new JSONObject();
        try {
            sbean.setData(orderjson);
            fond = send.sendPost(requestUrl, JSONObject.fromObject(sbean));

            LOGGER.info("订购参数：" + orderjson.toString() + "订购结果：" + fond.toString());
        } catch (Exception e) {
            e.printStackTrace();
            fond.put("resultCode", "0101");
            fond.put("errorInfo", "订购失败，操作数据错误，请稍后重试!");
        }
        // 成功订购发送短信
        if (fond.get("resultCode").equals("0000")) {

            DirectedJyOrderBean directedJyOrderBean = new DirectedJyOrderBean();
            String orderid = SerialnumberUtil.Getnum(10000000,99999999);
            directedJyOrderBean.setOrderid(orderid);
            directedJyOrderBean.setCpid(sbean.getCpid());
            directedJyOrderBean.setBusiid(orderjson.getString("busiid"));
            directedJyOrderBean.setUsermob(orderjson.getString("usermob"));
            directedJyOrderBean.setProductid(orderjson.getString("productid"));
            directedJyOrderBean.setUseraccount(orderjson.getString("useraccount"));
            directedJyOrderBean.setOrderchannel(orderjson.getString("orderchannel"));

            try {
                dao.insertDirectedJyBean(directedJyOrderBean);
                //dao.insertDirectedJyLog(logBean);
            } catch (Exception e) {
                e.printStackTrace();
            }

            //记录日志表
            DirectedJyLogBean logBean = new DirectedJyLogBean();
            logBean.setOrderid(orderid);
            logBean.setCpid(sbean.getCpid());
            logBean.setBusiid(orderjson.getString("busiid"));
            logBean.setUsermob(orderjson.getString("usermob"));
            logBean.setProductid(orderjson.getString("productid"));
            logBean.setUseraccount(orderjson.getString("useraccount"));
            logBean.setOrderchannel(orderjson.getString("orderchannel"));
            logBean.setRequestparam(JSONObject.fromObject(sbean).toString());
            logBean.setResponsecode(fond.get("resultCode").toString());
            logBean.setResponseinfo(fond.get("errorInfo").toString());
            try {
                dao.insertDirectedJyLog(logBean);
            } catch (Exception e) {
                e.printStackTrace();
            }

            SmsBean sms = new SmsBean();
            sms.setBusiid("sms");
            sms.setUsermob(data.getString("usermob"));
            try {
                sms.setSmstype(dao.querySms(Util._N_to_10((String) data.get("fes"), 32), Util.fogdec(data.getString("fog"), "cpid"), Util.fogdec(data.getString("fog"), "productid"), 0));
            } catch (Exception e1) {
                e1.printStackTrace();
            }
            sms.setSmscontent("");
            JSONObject smsJson = JSONObject.fromObject(sms);
            try {
                sbean.setData(smsJson);
            } catch (Exception e) {
                e.printStackTrace();
            }
            JSONObject reJson = send.sendPost(requestUrl, JSONObject.fromObject(sbean));
            LOGGER.info(reJson.toString());
        }
        return fond;
    }

    /**
     * 查询
     */
    @Override
    public JSONObject orderQuery(JSONObject data) {
        JSONObject orderjson = new JSONObject();
        orderjson.put("busiid", "queryFlow");
        orderjson.put("usermob", data.getString("usermob"));
        orderjson.put("productid", Util.fogdec(data.getString("fog"), "productid"));
        // 默认查询当前月份
        orderjson.put("month", Util.getMoth());
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        JSONObject fond = new JSONObject();
        try {
            sbean.setData(orderjson);
            fond = send.sendPost(requestUrl, JSONObject.fromObject(sbean));
        } catch (Exception e) {
            e.printStackTrace();
            fond.put("resultCode", "0101");
            fond.put("errorInfo", "查询失败，操作数据错误，请稍后重试!");
        }
        if (fond.get("resultCode").equals("0000")) {
            try {
                String da = AESUtil.decrypt(fond.get("queryflow").toString(),
                        Util.keyMap.get(Util.fogdec(data.getString("fog"),
                                "cpid")));
                fond.put("data", da);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        //记录日志表
        DirectedJyLogBean logBean = new DirectedJyLogBean();
        String orderid = SerialnumberUtil.Getnum(10000000,99999999);
        logBean.setOrderid(orderid);
        logBean.setCpid(sbean.getCpid());
        logBean.setBusiid(orderjson.getString("busiid"));
        logBean.setUsermob(orderjson.getString("usermob"));
        logBean.setProductid(orderjson.getString("productid"));
        logBean.setRequestparam(JSONObject.fromObject(sbean).toString());
        logBean.setResponsecode(fond.get("resultCode").toString());
        logBean.setResponseinfo(fond.get("errorInfo").toString());
        try {
            dao.insertDirectedJyLog(logBean);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return fond;
    }

    /**
     * 退订渠道
     */
    @Override
    public JSONObject orderCancel(JSONObject data) {
        JSONObject orderjson = new JSONObject();
        orderjson.put("busiid", "cancel");
        orderjson.put("usermob", data.getString("usermob"));
        orderjson.put("productid",
                Util.fogdec(data.getString("fog"), "productid"));
        orderjson.put("useraccount", data.getString("useraccount"));
        orderjson.put("cancelchannel", data.getString("sou"));// 退订渠道默认线上
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        JSONObject fond = new JSONObject();
        try {
            sbean.setData(orderjson);
            fond = send.sendPost(requestUrl, JSONObject.fromObject(sbean));
        } catch (Exception e) {
            e.printStackTrace();
            fond.put("resultCode", "0101");
            fond.put("errorInfo", "退订失败，操作数据错误，请稍后重试!");
        }
        if (fond.get("resultCode").equals("0000")) {// 成功退订发送短信

            DirectedJyOrderBean directedJyOrderBean = new DirectedJyOrderBean();
            directedJyOrderBean.setUsermob(orderjson.getString("usermob"));
            directedJyOrderBean.setProductid(orderjson.getString("productid"));
            directedJyOrderBean.setCurstatus(orderjson.getString("curstatus"));
            directedJyOrderBean.setCancelchannel(orderjson.getString("cancelchannel"));
            try {
                dao.cancelOrder(directedJyOrderBean);
            } catch (Exception e) {
                e.printStackTrace();
            }

            SmsBean sms = new SmsBean();
            sms.setBusiid("sms");
            sms.setUsermob(data.getString("usermob"));
            try {
                sms.setSmstype(dao.querySms(Util._N_to_10((String) data.get("fes"), 32), Util.fogdec(data.getString("fog"), "cpid"), Util.fogdec(data.getString("fog"), "productid"), 1));
            } catch (Exception e1) {
                e1.printStackTrace();
            }
            sms.setSmscontent("");
            JSONObject smsJson = JSONObject.fromObject(sms);
            try {
                sbean.setData(smsJson);
            } catch (Exception e) {
                e.printStackTrace();
            }
            JSONObject reJson = send.sendPost(requestUrl,
                    JSONObject.fromObject(sbean));
            LOGGER.info(reJson.toString());
        }

        //记录日志表
        DirectedJyLogBean logBean = new DirectedJyLogBean();
        String orderid = SerialnumberUtil.Getnum(10000000,99999999);
        logBean.setOrderid(orderid);
        logBean.setCpid(sbean.getCpid());
        logBean.setBusiid(orderjson.getString("busiid"));
        logBean.setUsermob(orderjson.getString("usermob"));
        logBean.setProductid(orderjson.getString("productid"));
        logBean.setUseraccount(orderjson.getString("useraccount"));
        logBean.setCancelchannel(orderjson.getString("cancelchannel"));
        logBean.setRequestparam(JSONObject.fromObject(sbean).toString());
        logBean.setResponsecode(fond.get("resultCode").toString());
        logBean.setResponseinfo(fond.get("errorInfo").toString());
        try {
            dao.insertDirectedJyLog(logBean);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return fond;
    }

    /**
     * 激活查看用户订购关系
     */
    @Override
    public JSONObject activate(JSONObject data) {
        JSONObject orderjson = new JSONObject();
        orderjson.put("busiid", "queryOrderInfo");
        orderjson.put("usermob", data.getString("usermob"));
        orderjson.put("productid",
                Util.fogdec(data.getString("fog"), "productid"));
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        JSONObject fond = new JSONObject();
        try {
            sbean.setData(orderjson);
            fond = send.sendPost(requestUrl, JSONObject.fromObject(sbean));
        } catch (Exception e) {
            e.printStackTrace();
            fond.put("resultCode", "0101");
            fond.put("errorInfo", "查询失败，操作数据错误，请稍后重试!");
        }
        return fond;
    }

    /**
     * 将url 后缀cpid与productid 加密返回. 不推荐使用保留
     */
    @Override
    public JSONObject orderEncrypt(JSONObject data) {
        JSONObject fond = new JSONObject();
        try {
            fond.put("resultCode", "0000");
            fond.put(
                    "data",
                    AESUtil.encrypt(data.get("masg").toString(),
                            Util.geturlkeyWord()));
        } catch (Exception e) {
            e.printStackTrace();
            fond.put("resultCode", "0201");
            fond.put("errorInfo", "加密结果失败");
        }
        return fond;
    }

    /**
     * 将url 后缀cpid与productid 解密返回. 不推荐使用保留
     */
    @Override
    public JSONObject orderDecrypt(JSONObject data) {
        JSONObject fond = new JSONObject();
        try {
            fond.put("resultCode", "0000");
            fond.put(
                    "data",
                    AESUtil.decrypt(data.get("masg").toString(),
                            Util.geturlkeyWord()));
        } catch (Exception e) {
            e.printStackTrace();
            fond.put("resultCode", "0201");
            fond.put("errorInfo", "解密结果失败");
        }
        return fond;
    }

    /**
     * 获取对应活动组中对应产品信息
     */
    @Override
    public JSONObject GetFestival(JSONObject data) {
        // TODO Auto-generated method stub
        //dao
        return null;
    }

}
