package com.chinacreator.order.service.imp;

import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.bean.SmsBean;
import com.chinacreator.order.dao.imp.QueryDaoImp;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.service.SmsService;
import com.chinacreator.order.util.Util;
import net.sf.json.JSONObject;

import javax.servlet.http.HttpServletRequest;

public class SmsServiceImp implements SmsService {
    public static final String requestUrl = Util.getsendUrl();
    public static HttpSendServicImp send = new HttpSendServicImp();
    public static QueryDaoImp dao = new QueryDaoImp();
    
    @Override
    public JSONObject SmsSend(JSONObject data, HttpServletRequest request) {
        SmsBean sms = new SmsBean();
        JSONObject errjson = new JSONObject();
        sms.setBusiid("sms");
        System.out.println("短信接口请求数据---------------------" + data.toString());
        // 根据fog与fes值获取tb_ordercenter_product表中值
        sms.setSmstype(data.getString("smstype"));
        sms.setUsermob(data.getString("usermob"));
        try {
            String code = Util.createRandomVcode();// 获取验证码
            sms.setSmscontent(code);
            JSONObject smsJson = JSONObject.fromObject(sms);
            SendBean sbean = new SendBean();
            sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
            sbean.setData(smsJson);
            // 判断同一手机号同服务验证码是否在短时间多次发送
            // 判断是否达到上限
            if (dao.intcodeLim(data.getString("usermob"), Util.fogdec(data.getString("fog"), "cpid"), data.getString("smstype")) <= 10) {
                if (dao.intcodeTim(data.getString("usermob"), Util.fogdec(data.getString("fog"), "cpid"), data.getString("smstype"))) {
                    errjson = send.sendPost(requestUrl, JSONObject.fromObject(sbean));
                    // 判断是否发送成功存库
                    if (errjson.getString("resultCode").equals("0000")) {
                        dao.insertCode(
                                Util.fogdec(data.getString("fog"), "cpid"),
                                Util.fogdec(data.getString("fog"), "productid"),
                                code,
                                data.getString("usermob"),
                                data.getString("smstype"),
                                Integer.valueOf(Util._N_to_10((String) data.get("sou"), 32))
                        );
                        if (dao.intcodeLim(data.getString("usermob"), Util.fogdec(data.getString("fog"), "cpid"), data.getString("smstype")) == 0) {// 若不存在此电话号记录数据存入
                            dao.insertCodeLim(data.getString("usermob"), Util.fogdec(data.getString("fog"), "cpid"), data.getString("smstype"));
                        } else {
                            dao.updatecodeLim(data.getString("usermob"), Util.fogdec(data.getString("fog"), "cpid"), data.getString("smstype"));
                        }
                    }
                } else {
                    errjson.put("resultCode", "8002");
                    errjson.put("errorInfo", "请勿重复请求!");
                }
            } else {// 短信同类型达到上限
                errjson.put("resultCode", "8001");
                errjson.put("errorInfo", "此号码短信已达上限，请明日在试");
            }
        } catch (Exception e) {
            errjson.put("resultCode", "8000");
            errjson.put("errorInfo", "系统忙，请稍候再试");
            e.printStackTrace();
        }
        return errjson;
    }
}
