package com.chinacreator.order.servlet;

import com.chinacreator.order.agency.LogInvoHandler;
import com.chinacreator.order.service.OrderService;
import com.chinacreator.order.service.imp.OrderServiceImp;
import net.sf.json.JSONObject;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;

public class AesServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;

    private OrderService service = LogInvoHandler
            .getProxyInstance(OrderServiceImp.class);

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        doPost(req, resp);
    }

    /**
     * 加密解密接口(用于测试生成加密链接)
     */
    @Override
    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        StringBuffer reqjson = new StringBuffer();
        String line = null;
        try {
            BufferedReader reader = request.getReader();
            while ((line = reader.readLine()) != null) {
                reqjson.append(line);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        JSONObject data = JSONObject.fromObject(reqjson.toString());
        JSONObject json = new JSONObject();
        if (data.get("fog").equals("0")) {
            json = service.orderEncrypt(data);//加密
        }
        if (data.get("fog").equals("1")) {
            json = service.orderDecrypt(data);//加密
        }
        OutputStream out = response.getOutputStream();
        out.write(json.toString().getBytes(StandardCharsets.UTF_8));
        out.flush();
    }

}
