package com.chinacreator.order.servlet;

import com.chinacreator.order.agency.LogInvoHandler;
import com.chinacreator.order.service.OrderService;
import com.chinacreator.order.service.imp.OrderServiceImp;
import com.chinacreator.order.util.Util;
import net.sf.json.JSONObject;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;

public class CancelServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;

    private OrderService service = LogInvoHandler
            .getProxyInstance(OrderServiceImp.class);

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        doPost(req, resp);
    }

    /**
     * 退订接口
     */
    @Override
    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        StringBuffer reqjson = new StringBuffer();
        String line = null;
        try {
            BufferedReader reader = request.getReader();
            while ((line = reader.readLine()) != null) {
                reqjson.append(line);
            }
        } catch (Exception e) {
            System.out.println(e.toString());
        }
        JSONObject data = JSONObject.fromObject(reqjson.toString());
        JSONObject json = new JSONObject();
        // 判断验证码
        if (Util.bcode(data)) {
            json = service.orderCancel(data);
        } else {
            json.put("resultCode", "6611");
            json.put("errorInfo", "验证码错误");
        }
// 		判断是否传入code如果没有是初始加载判断结果
//		if (data.get("code") == null) {
//			json = service.activate(data);
//		} else {// 有验证码时判断验证码.
//			if (Util.bcode(data)) {
//				json = service.activate(data);
//			} else {
//				json.put("resultCode", "6611");
//				json.put("errorInfo", "验证码错误");
//			}
//		}
        OutputStream out = response.getOutputStream();
        out.write(json.toString().getBytes(StandardCharsets.UTF_8));
        out.flush();
    }

}
