package com.chinacreator.order.servlet;

import com.chinacreator.order.agency.LogInvoHandler;
import com.chinacreator.order.service.OrderService;
import com.chinacreator.order.service.imp.OrderServiceImp;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;

public class QueryFlowServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;
    private Logger logger = LoggerFactory.getLogger(this.getClass().getSimpleName());
    private OrderService service = LogInvoHandler
            .getProxyInstance(OrderServiceImp.class);

    /**
     * 流量查询接口
     */
    @Override
    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        StringBuffer reqjson = new StringBuffer();
        String line = null;
        try {
            BufferedReader reader = request.getReader();
            while ((line = reader.readLine()) != null) {
                reqjson.append(line);
            }
        } catch (Exception e) {
            logger.error(e.toString());
        }
        JSONObject data = JSONObject.fromObject(reqjson.toString());
        JSONObject json = new JSONObject();
        json = service.orderQuery(data);
        OutputStream out = response.getOutputStream();
        out.write(json.toString().getBytes(StandardCharsets.UTF_8));
        out.flush();
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        super.doPost(req, resp);
    }

}
