package com.chinacreator.order.servlet;

import com.chinacreator.access.util.IpAddrUtil;
import com.chinacreator.order.service.imp.SmsServiceImp;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;

public class SmsServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;
    private Logger logger = LoggerFactory.getLogger(this.getClass().getSimpleName());
    private SmsServiceImp service = new SmsServiceImp();

    /**
     * 验证码发送接口
     */
    @Override
    @Deprecated
    protected void doPost(HttpServletRequest request,
                          HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        StringBuffer reqjson = new StringBuffer();
        String line = null;
        try {
            BufferedReader reader = request.getReader();
            while ((line = reader.readLine()) != null) {
                reqjson.append(line);
            }
        } catch (Exception e) {
            logger.error(e.toString());
        }
        JSONObject data = JSONObject.fromObject(reqjson.toString());

        // 接口已经弃用，只允发这两个短信
        switch (data.getString("smstype")) {
            case "431":
            case "427":
                break;
            default:
                logger.error("异常短信，" + reqjson + "," + IpAddrUtil.getIpAddr(request));
                data.put("smstype", "427");
                break;
        }

        JSONObject json = service.SmsSend(data, request);
        OutputStream out = response.getOutputStream();
        out.write(json.toString().getBytes(StandardCharsets.UTF_8));
        out.flush();
    }

    @Override
    protected void doGet(HttpServletRequest request,
                         HttpServletResponse response) throws ServletException, IOException {
        doPost(request, response);
    }
}
