package com.chinacreator.order.util;

import com.alibaba.fastjson.JSON;
import com.chinacreator.access.bean.FesMessage;
import com.chinacreator.access.restrain.ReqEnum;
import com.chinacreator.access.service.ChannelInfoService;
import com.chinacreator.access.service.DxService;
import com.chinacreator.order.agency.LogInvoHandler;
import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.dao.QueryDao;
import com.chinacreator.order.dao.imp.QueryDaoImp;
import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.io.InputStream;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;


public class Util {
    private final static Logger logger = LoggerFactory.getLogger(DxService.class);

    //秘钥缓存Map
    public static HashMap<String, String> keyMap = new HashMap<String, String>();
    //产品组缓存List(包括产品)
    public static ArrayList<FesMessage> fesList = new ArrayList<FesMessage>();
    static HttpSendService send = new HttpSendServicImp();
    private static QueryDao dao = LogInvoHandler.getProxyInstance(QueryDaoImp.class);
    private static Random random = new Random();
    private static SimpleDateFormat sdf = null;
    private static String sendUrl = null;
    private static String requestUrl = null;
    private static String urlkeyWord = null;//url参数加密秘钥
    private static String ttSyncUrl = null;//头条同步地址
    private static String touTiaoToPhone = null;//头条设备号获取手机号链接
    private static String wySyncUrl = null;//网易同步地址
    private static Map<String, String> usermap = null;//头条设备号获取手机号链接
    private static String tb = null;//定时标示
    private static String numStr = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    private static char[] array = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();

//	/**
//	 *判断是否存在缓存
//	 */
//	public static boolean getUsermap(String usermob,String timec){
//		if(usermap.containsKey(usermob)){
//			//判断缓存中是否存在此号码
//			//存在此号码
//			//然而类存中时间区间
//			String timeid =  usermap.get(usermob);//获取内存中标记
//			if(coptiem(timeid,timec)){//时间标记对比
//				System.out.println("内存中记录标记小于当前请求标记");
//				System.out.println("小于为正确");
//				//当前请求所使用的时间标记，大于
//				setUsermap(usermob, timec);
//				return true;
//			}else {
//				System.out.println("内存中记录标记大于等于当前请求标记");
//				//TODO 将时间先知调整至2分钟
//				System.out.println("大于为失败");
//				return false;
//			}
//		}else {//不存在此号码
//			Timestamp dbtimelos = Util.beforeDate(2);
//			//服务器2分钟前时间，如果小于用户时间
//			if(coptiem(dbtimelos.toString(),timec)){
//				setUsermap(usermob,timec);
//				return true;
//			}else {
//				System.out.println("没有号码");
//				return false;
//			}
//		}
//	}
    private static String varSmsKey = "12345678";

    static {
        initConfig();
    }

    public Util() {
        super();
    }

    /**
     * 存用户参数缓存
     */
    public static void setUsermap(String usermob, String timec) {
        usermap.put(usermob, timec);
    }

    public static boolean coptiem(String timeid, String timec) {
        try {
            return copTimec(sdf.parse(timeid), sdf.parse(timec));
        } catch (ParseException e) {
            //TODO 日志不标准
            return false;
        }
    }

    /**
     * 读取配置文件
     */
    private static void initConfig() {

        InputStream inf = Util.class.getClassLoader().getResourceAsStream(
                "application.properties");
        Properties properties = new Properties();
        try {
            properties.load(inf);
            sdf = new SimpleDateFormat(properties.getProperty("sdf"));
            sendUrl = properties.getProperty("sendUrl");
            requestUrl = properties.getProperty("requestUrl");
            urlkeyWord = properties.getProperty("urlkeyWord");
            ttSyncUrl = properties.getProperty("ttSyncUrl");
            wySyncUrl = properties.getProperty("wySyncUrl");
            touTiaoToPhone = properties.getProperty("touTiaoToPhone");
            tb = properties.getProperty("tb");
            usermap = new HashMap<String, String>();
            //fesList = partService.getAllFesMessage();
            System.out.println("初始化配置:---平台请求地址sendUrl:" + sendUrl);
            System.out.println("初始化配置:---url加密参数秘钥urlkeyWord:" + urlkeyWord);
            System.out.println("初始化配置:---touTiaoAppUrl:" + ttSyncUrl);
            System.out.println("初始化配置:---wySyncUrl:" + wySyncUrl);
            System.out.println("初始化配置:---tb:" + tb);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    /**
     * 获取缓存中 对应cpid 秘钥
     *
     * @return
     */
    public static String getkeyMap(String cpid) {
        String keyWord = null;
        if (Util.keyMap.get(cpid) == null) {
            QueryDao dao = new QueryDaoImp();
            try {
                keyWord = dao.querykeyWord(cpid);
            } catch (Exception e) {
                e.printStackTrace();
            }
            if (keyWord != null) {
                Util.keyMap.put(cpid, keyWord);
            } else {
                System.err.println("keyword未能取出");
            }
        } else {
            keyWord = Util.keyMap.get(cpid);
        }
        return keyWord;
    }

    /**
     * 获取同步标示
     *
     * @return
     */
    public static String gettb() {
        if (tb == null) {
            initConfig();
        }
        return tb;
    }

    /**
     * 获取url秘钥
     *
     * @return
     */
    public static String geturlkeyWord() {
        if (urlkeyWord == null) {
            initConfig();
        }
        return urlkeyWord;
    }

    /**
     * 获取平台发送地址
     *
     * @return
     */
    public static String getsendUrl() {
        if (sendUrl == null) {
            initConfig();
        }
        return sendUrl;
    }

    /**
     * 获取平台发送地址
     *
     * @return
     */
    public static String getrequestUrl() {
        if (requestUrl == null) {
            initConfig();
        }
        return requestUrl;
    }

    /**
     * 获取头条同步地址
     *
     * @return
     */
    public static String getTtSyncUrl() {
        if (ttSyncUrl == null) {
            initConfig();
        }
        return ttSyncUrl;
    }

    /**
     * 获取网易互娱同步地址
     *
     * @return
     */
    public static String getWySyncUrl() {
        if (wySyncUrl == null) {
            initConfig();
        }
        return wySyncUrl;
    }

    /**
     * 获取平台发送地址
     *
     * @return
     */
    public static String gettouTiaoToPhone() {
        if (touTiaoToPhone == null) {
            initConfig();
        }
        return touTiaoToPhone;
    }

    /**
     * 获取流量查询默认时间格式
     *
     * @return
     */
    public static SimpleDateFormat getsdf() {
        if (sdf == null) {
            initConfig();
        }
        return sdf;
    }

    /**
     * 6位数随机数
     *
     * @return
     */
    public static String createRandomVcode() {
        String vcode = "";
        for (int i = 0; i < 6; i++) {
            vcode = vcode + (int) (Math.random() * 9);
        }
        return vcode;
    }

    /**
     * 获取当前时间的sdf格式日期
     *
     * @return
     */
    public static String getMoth() {
        return getsdf().format(new Date());
    }

    /**
     * @param fog 加密的cpid与productid
     * @param key 需要获取的参数至 cpid/productid
     * @return 获取的对应参数
     * @throws Exception 解密失败
     */
    public static String fogdec(String fog, String key) {
        String fogo = "";
        try {
            fogo = AESUtil.decrypt(fog, geturlkeyWord());
        } catch (Exception e) {
            //TODO 后续修改异常全部向上抛出
            e.printStackTrace();
        }
        String[] arrSplit = null;
        arrSplit = fogo.split("[&]");
        JSONObject fogJson = new JSONObject();
        for (String strSplit : arrSplit) {
            System.out.println(strSplit);
            String[] arrSplitEqual = null;
            arrSplitEqual = strSplit.split("[=]");
            fogJson.put(arrSplitEqual[0], arrSplitEqual.length>1?arrSplitEqual[1]:"");
        }

        if (fogJson.containsKey(key)) {
            return fogJson.getString(key);
        }

        return null;
    }

    /**
     * 替换fog中productid参数
     *
     * @param fog
     * @param productid
     * @return
     * @throws Exception
     */
    public static String fogret(String fog, String productid) throws Exception {
        String fogo = AESUtil.decrypt(fog, geturlkeyWord());
        System.out.println(fogo);
        String md = fogo.substring(0, fogo.indexOf("productid="));
        md = md + "productid=" + productid;
        System.out.println("添加新productid之后" + md);
        return AESUtil.encrypt(md, geturlkeyWord());
    }

    /**
     * 获取当前时间特定分钟的时间
     *
     * @param t 多少分钟之前
     * @return t时间前的时间
     */
    public static Timestamp beforeDate(int t) {
        Calendar beforeTime = Calendar.getInstance();
        beforeTime.add(Calendar.MINUTE, -t);// 3分钟之前的时间
        Date beforeD = beforeTime.getTime();
        Timestamp btamp = new Timestamp(beforeD.getTime());
        return btamp;
    }

    public static Timestamp beforeDate(int t, int type) {
        Calendar beforeTime = Calendar.getInstance();
        if (type == 0) {
            beforeTime.add(Calendar.MINUTE, -t);//t分钟之前的时间
        }
        if (type == 1) {
            beforeTime.add(Calendar.MINUTE, t);//t分钟之后的时间
        }
        Date beforeD = beforeTime.getTime();
        Timestamp btamp = new Timestamp(beforeD.getTime());
        return btamp;
    }

    public static String getDate() {
        Date d = new Date();
        //TODO 此处应改造配置文件读取时间格式.
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(d);
    }

    /**
     * 对比验证码
     *
     * @param data 请求过来的数据
     * @return 对比结果
     */
    public static boolean bcode(JSONObject data) {
        boolean c = false;
        try {
            c = dao.updateCode(Util.fogdec(data.getString("fog"), "cpid"), Util.fogdec(data.getString("fog"), "productid"), data.getString("code"), data.getString("usermob"));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return c;
    }

    /**
     * 时间比对工具类 stime<todate<etime
     *
     * @param stime 开始时间
     * @param etime 结束时间
     * @return 0:当前时间在时间段中  1:当前时间在时间段之前(还未开始) 2:当前时间在时间段之后(以结束)
     */
    public static int copTime(Date stime, Date etime) {
        Date todate = new Date();
        if (stime.before(todate)) {
            if (todate.before(etime)) {
                return 0;
            } else {
                return 2;
            }
        } else {
            return 1;
        }
    }

    /**
     * @param stime
     * @param etime
     * @return
     */
    public static boolean copTimec(Date stime, Date etime) {
        boolean cop = false;
        if (stime.before(etime)) {
            cop = true;
        }
        return cop;
    }

    /**
     * 生成错误信息Json对象
     *
     * @param enu 返回结果的枚举
     * @return 结果Json
     */
    public static com.alibaba.fastjson.JSONObject reqAliJsonErr(ReqEnum enu) {
        com.alibaba.fastjson.JSONObject errJson = new com.alibaba.fastjson.JSONObject();
        errJson.put("resultCode", enu.getResultCode());
        errJson.put("errorInfo", enu.getErrorInfo());
        return errJson;
    }

    /**
     * 生成错误信息Json对象
     *
     * @param enu 返回结果的枚举
     * @return 结果Json
     */
    @Deprecated
    public static JSONObject reqJsonErr(ReqEnum enu) {
        JSONObject errJson = new JSONObject();
        errJson.put("resultCode", enu.getResultCode());
        errJson.put("errorInfo", enu.getErrorInfo());
        return errJson;
    }

    public static JSONObject reqJson(ReqEnum enu, JSONObject reqjson, ArrayList<JSONObject> pageIni) {
        JSONObject reqJson = new JSONObject();
        reqJson.put("resultCode", enu.getResultCode());
        reqJson.put("errorInfo", enu.getErrorInfo());
        reqJson.put("festival", reqjson);
        reqJson.put("product", pageIni);
        return reqJson;
    }

    /**
     * 进制转换工具类 N转10
     *
     * @param number 需要转换的字符串
     * @param N      number位数
     * @return 结果
     */
    public static String _N_to_10(String number, int N) {
        char[] ch = number.toLowerCase().toCharArray();
        int len = ch.length;
        long result = 0;
        if (N == 10) {
            return Long.toString(Long.parseLong(number.toLowerCase()));
        }
        long base = 1;
        for (int i = len - 1; i >= 0; i--) {
            int index = numStr.indexOf(ch[i]);
            result += index * base;
            base *= N;
        }
        return Long.toString(result);
    }

    /**
     * 进制转换工具类 10转N
     *
     * @param number 需要转换的字符串(10进制)
     * @param N      number位数
     * @return 结果
     */
    public static String _10_to_N(String number, int N) {
        Long rest = Long.valueOf(number.toLowerCase());
        Stack<Character> stack = new Stack<Character>();
        StringBuilder result = new StringBuilder(0);
        while (rest != 0) {
            stack.add(array[new Long((rest % N)).intValue()]);
            rest = rest / N;
        }
        for (; !stack.isEmpty(); ) {
            result.append(stack.pop());
        }
        return result.length() == 0 ? "0" : result.toString();

    }

    /**
     * 随机数生成工具类
     *
     * @param min 最小值 默认0
     * @param max 最大值
     * @return
     */
    public static int randomSection(int min, int max) {
        return random.nextInt(max) % (max - min + 1) + min;
    }

    /**
     * 订购退订请求数据包装
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购  1退订  3统一认证订购
     * @return
     * @throws Exception
     */
    public static SendBean retOrderBean(com.alibaba.fastjson.JSONObject data, int i) throws Exception {
        JSONObject json = new JSONObject();
        if (i == 0) {
            json.put("busiid", "unOrder");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("token", data.getString("token"));
        }
        if (i == 1) {
            json.put("busiid", "cancel");
            json.put("cancelchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("canceltype", data.getString("canceltype"));
            json.put("cancelmsg", data.getString("cancelmsg"));
        }
        if (i == 4) {
            json.put("busiid", "order");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("token", data.getString("token"));
        }
        json.put("usermob", data.getString("usermob"));
        json.put("productid", Util.fogdec(data.getString("fog"), "productid"));
        json.put("useraccount", data.getString("useraccount"));
        if (data.containsKey("alichannel")
                && !"".equals(data.getString("alichannel"))
                && !"null".equals(data.getString("alichannel"))
                && !"undefined".equals(data.getString("alichannel"))) {
            json.put("alichannel", data.getString("alichannel"));
        }

        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);
        logger.info("订购参数：加密前={}，加密后={}", sbean, json);

        return sbean;
    }

    /**
     * 今日头条视频彩铃流量融合包
     */
    public static SendBean retRbtOrderBean(com.alibaba.fastjson.JSONObject data, int i) throws Exception {
        JSONObject json = new JSONObject();

        if (i == 0) {
            json.put("busiid", "unRbtOrder");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("token", data.getString("token"));
            // 彩铃设置编码（铃音ID/铃音组ID）
            json.put("ringid", data.getString("ringid"));
            // true:发短信，false:不发（默认发）
            json.put("issms", "true");
        } else if (i == 1) {
            json.put("busiid", "rbtCancel");
            json.put("cancelchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("canceltype", data.getString("canceltype"));
            json.put("cancelmsg", data.getString("cancelmsg"));
        } else if (i == 2) {
            json.put("busiid", "rbtQuery");
            json.put("cancelchannel", Util._N_to_10(data.getString("sou"), 32));
        } else if (i == 3) {//设置视频彩铃
            json.put("busiid", "rbtRing");
            json.put("ringid", data.getString("ringid"));
            // true:发短信，false:不发（默认发）
            json.put("issms", "true");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
        } else if (i == 4) {
            //手厅视频彩铃订购
            json.put("busiid", "rbtOrder");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            // 彩铃设置编码（铃音ID/铃音组ID）
            json.put("ringid", data.getString("ringid"));
            // true:发短信，false:不发（默认发）
            json.put("issms", "true");
        }

        json.put("usermob", data.getString("usermob"));
        json.put("productid", Util.fogdec(data.getString("fog"), "productid"));
        json.put("useraccount", data.getString("useraccount"));
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);
        logger.info("视频彩铃订购参数：加密前={}，加密后={}", json.toString(), sbean.toString());
        return sbean;
    }

    /**
     * 订购退订请求数据包装
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购  1退订  3统一认证订购
     * @return
     * @throws Exception
     */
    @Deprecated
    public static SendBean retOrderBean(JSONObject data, int i) throws Exception {
        JSONObject json = new JSONObject();
        if (i == 0) {
            json.put("busiid", "unOrder");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("token", data.getString("token"));
        }
        if (i == 1) {
            json.put("busiid", "cancel");
            json.put("cancelchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("canceltype", data.getString("canceltype"));
            json.put("cancelmsg", data.getString("cancelmsg"));
        }
        if (i == 4) {
            json.put("busiid", "order");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("token", data.getString("token"));
        }
        json.put("usermob", data.getString("usermob"));
        json.put("productid", Util.fogdec(data.getString("fog"), "productid"));
        json.put("useraccount", data.getString("useraccount"));

        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);

        logger.info("订购参数：加密前={}，加密后={}" + json, JSON.toJSONString(sbean));

        return sbean;
    }

    public static SendBean retYuYueOrderBean(JSONObject data) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "order");
        json.put("orderchannel", data.getString("sou"));
        json.put("usermob", data.getString("usermob"));
        json.put("productid", data.getString("productid"));
        json.put("useraccount", data.getString("useraccount"));
        SendBean sbean = new SendBean();
        sbean.setCpid(data.getString("cpid"));
        sbean.setData(json);
        return sbean;
    }

    public static SendBean queryOrderBean(com.alibaba.fastjson.JSONObject data) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "queryOrderInfo");
        json.put("usermob", data.getString("usermob"));
        json.put("productid", data.getString("productid"));
        SendBean sbean = new SendBean();
        sbean.setCpid(data.getString("cpid"));
        sbean.setData(json);
        return sbean;
    }

    public static SendBean queryInfoBean(com.alibaba.fastjson.JSONObject data) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "queryinfo");
        json.put("usermob", data.getString("usermob"));
        json.put("productid", data.getString("productid"));
        SendBean sbean = new SendBean();
        sbean.setCpid(data.getString("cpid"));
        sbean.setData(json);
        return sbean;
    }

    @Deprecated
    public static SendBean queryOrderBean(JSONObject data) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "queryOrderInfo");
        json.put("usermob", data.getString("usermob"));
        json.put("productid", data.getString("productid"));
        SendBean sbean = new SendBean();
        sbean.setCpid(data.getString("cpid"));
        sbean.setData(json);
        return sbean;
    }

    /**
     * 退订请求数据包装,包装特定productid
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购  1退订
     * @return
     * @throws Exception
     */
    public static SendBean retOrderBean(JSONObject data, String productid, int i) throws Exception {
        JSONObject json = new JSONObject();
        if (i == 0) {
            json.put("busiid", "order");
            json.put("orderchannel", Util._N_to_10(data.getString("sou"), 32));
        }
        if (i == 1) {
            json.put("busiid", "cancel");
            json.put("cancelchannel", Util._N_to_10(data.getString("sou"), 32));
            json.put("canceltype", data.getString("canceltype"));
            json.put("cancelmsg", data.getString("cancelmsg"));
        }
        json.put("usermob", data.getString("usermob"));
        json.put("productid", productid);
        json.put("useraccount", data.getString("useraccount"));
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);
        return sbean;
    }

    public static SendBean retSmsBean(com.alibaba.fastjson.JSONObject data, int i) throws Exception {
        // String fescode = Util._N_to_10((String) data.get("fes"), 32);
        String fescode = Util.fogdec(data.getString("fog"), "fescod");
        String newFescod = data.getString("new_fescod");
        fescode = (newFescod == null ? fescode : newFescod);

        String cpid = Util.fogdec(data.getString("fog"), "cpid");
        String productid = Util.fogdec(data.getString("fog"), "productid");

        String smstype = String.valueOf(i);
        if (i <= 1) {
            smstype = dao.querySms(fescode, cpid, productid, i);
        }
        data.put("smstype", smstype);

        JSONObject json = new JSONObject();
        json.put("busiid", "sms");
        json.put("usermob", data.getString("usermob"));
        json.put("smstype", smstype);
        json.put("smscontent", "");
        if (data.containsKey("smschannel")) {
            json.put("smschannel", data.getString("smschannel"));
        }

        logger.info("短信发送内容：{}", json);
        SendBean sbean = new SendBean();
        sbean.setCpid(cpid);
        sbean.setData(json);
        return sbean;
    }

    /**
     * 订购退订短信发送包装
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购短信  1退订短信  2会员领取成功 3
     * @return
     * @throws Exception
     */
    public static SendBean retSmsBean(JSONObject data, int i) throws Exception {
        // String fescode = Util._N_to_10((String) data.get("fes"), 32);
        String fescode = Util.fogdec(data.getString("fog"), "fescod");
        String cpid = Util.fogdec(data.getString("fog"), "cpid");
        String productid = Util.fogdec(data.getString("fog"), "productid");

        String smstype = String.valueOf(i);
        if (i <= 1) {
            smstype = dao.querySms(fescode, cpid, productid, i);
        }

        JSONObject json = new JSONObject();
        json.put("busiid", "sms");
        json.put("usermob", data.getString("usermob"));
        json.put("smstype", smstype);
        json.put("smscontent", "");
        if (data.containsKey("smschannel")) {
            json.put("smschannel", data.getString("smschannel"));
        }

        logger.info("短信发送内容：{}", json);
        SendBean sbean = new SendBean();
        sbean.setCpid(cpid);
        sbean.setData(json);
        return sbean;
    }

    /**
     * 订购退订短信发送包装(包装特定productid)
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购短信  1退订短信
     * @return
     * @throws Exception
     */
    public static SendBean retSmsBean(JSONObject data, String productid, int i) throws Exception {
        // Util._N_to_10((String) data.get("fes"), 32);
        String fescode = Util.fogdec(data.getString("fog"), "fescod");
        JSONObject json = new JSONObject();
        json.put("busiid", "sms");
        json.put("usermob", data.getString("usermob"));
        json.put("smstype", dao.querySms(fescode, Util.fogdec(data.getString("fog"), "cpid"), productid, i));
        json.put("smscontent", "");
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);
        return sbean;
    }

    /**
     * 流量查询接口(包装特定productid)
     *
     * @param data 请求订购或退订包装后的Json数据
     * @return
     * @throws Exception
     */
    public static SendBean retFlowBean(com.alibaba.fastjson.JSONObject data, String productid) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "queryFlow");
        json.put("usermob", data.getString("usermob"));
        json.put("productid", productid);
        json.put("month", Util.getMoth());
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);
        return sbean;
    }

    /**
     * 流量查询接口(包装特定productid)
     *
     * @param data 请求订购或退订包装后的Json数据
     * @return
     * @throws Exception
     */
    @Deprecated
    public static SendBean retFlowBean(JSONObject data, String productid) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "queryFlow");
        json.put("usermob", data.getString("usermob"));
        json.put("productid", productid);
        json.put("month", Util.getMoth());
        SendBean sbean = new SendBean();
        sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
        sbean.setData(json);
        return sbean;
    }

    /**
     * 与客户同步数据包装json串用于发送至客户方
     * 存在产品A退订产品B问题故productid因明文
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购  1退订
     * @return
     * @throws Exception
     */
    public static String retactivateJsonString(JSONObject data, int i) throws Exception {
        JSONObject json = new JSONObject();
        json.put("sid", data.getString("sid"));
        json.put("usermob", data.getString("usermob"));
        json.put("productid", Util.fogdec(data.getString("fog"), "productid"));
        json.put("useraccount", data.getString("useraccount"));
        json.put("curstatus", i);//状态
        if (i == 2) {//号码激活不存在订购时间与退订时间
            json.put("ordertime", data.get("ordertime"));
            json.put("canceltime", data.get("canceltime"));
        }
        String sou = Util._N_to_10(data.getString("sou"), 32);
        json.put("channel", sou);
        System.out.println(json.toString());
        return json.toString();
    }

    /**
     * 与客户同步数据包装json串用于发送至客户方
     *
     * @param data 请求订购或退订包装后的Json数据
     * @param i    0 订购  1退订
     * @return
     * @throws Exception
     */
    public static JSONObject retactivateJson(JSONObject data, int i) throws Exception {
        JSONObject json = new JSONObject();
        json.put("usermob", data.getString("usermob"));
        json.put("productid", Util.fogdec(data.getString("fog"), "productid"));
        json.put("useraccount", data.getString("useraccount"));
        json.put("curstatus", i);//状态
        if (i == 0) {
            json.put("ordertime", i);
            json.put("canceltime", "");
        }
        if (i == 1) {
            json.put("ordertime", "");
            json.put("canceltime", i);
        }
        //TODO 渠道需处理.部分渠道订购的信息按照线上同步给客户
        String sou = Util._N_to_10(data.getString("sou"), 32);
        if (sou.equals("72")) {
            json.put("channel", "0");
        }
        json.put("channel", sou);
        return json;
    }

    public static JSONObject sendVerCode(JSONObject data) throws Exception {
        JSONObject json = new JSONObject();
        json.put("busiid", "sendsms");
        json.put("spcode", "106555061");
        JSONObject content = new JSONObject();
        content.put("SPNumber", "106555061");
        content.put("UserNumber", data.getString("usermob"));
        content.put("ReportFlag", "1");
        content.put("MessageContent", data.getString("content"));
        String con = "";
        con = DesUtilTo32.encode(content.toString(), varSmsKey);
        json.put("content", con);
        JSONObject re = send.sendPost(Util.getrequestUrl(), json);
        re.remove("SequenceNumber");
        return re;
    }

    /**
     * 获取年月
     *
     * @param i 前多少个月
     * @return
     */
    public static String getSyYM(int i) {
        SimpleDateFormat sdfYm = new SimpleDateFormat("yyyy-MM");
        Date date = new Date();
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.add(Calendar.MONTH, -i);
        return sdfYm.format(cal.getTime());
    }

    public static String Getnumc() {
        return Getnum(1000, 9999) + Getnum(1000, 9999) + Getnum(1000, 9999) + Getnum(1000, 9999);
    }

    public static String Getnum(int min, int max) {
        Random random = new Random();
        int s = random.nextInt(max) % (max - min + 1) + min;
        return String.valueOf(s);
    }

    public static void main(String[] args) throws Exception {
        System.out.println(_N_to_10("4R", 32));
        System.out.println(_N_to_10("4r", 32));
        String s = "f18720ee3445a9f6318503ec486cc1d753f7b6f16224dfb6f474ba672d222de78c08489547f5ecdf73a62721f2f3e7e590b27e37c07499b66adb88b022b2ee8226d5703e91d52b656de06b5d2c4fa7ab";
        System.out.println(AESUtil.decrypt(s, "Toutiao1@Unicom!"));
    }
}
