package com.chinacreator.csminiprogram;

import com.alibaba.fastjson.JSON;
import com.chinacreator.access.util.DESUtil;
import com.chinacreator.order.util.MD5;
import com.github.kevinsawicki.http.HttpRequest;
import org.junit.Test;

import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Map;

/**
 * 通过 畅视视频公众号 发送消息
 * 华盛提供
 */
public class ChangshiPublicAccountTemplateTest {

    /**
     * 测试地址
     */
    private static String testUrl = "https://wotest.mige.tv/jgj485-485jg/fkror_95489/backward/template/send";

    /**
     * 生产地址
     */
    private static String productUrl = "https://backward.mige.tv/jgj485-485jg/fkror_95489/backward/template/send";

    private static String password = "creators20210609!#@$";

    /**
     * 订购成功的模板消息
     * @throws Exception
     */
    @Test
    public void orderSuccessTemplate() throws Exception {
        Map<String, Object> map = new HashMap<>();

        Map<String, Object> varsMap = new HashMap<>();
        varsMap.put("keyword1", "快手定向流量5G加油包");
        varsMap.put("keyword2", "成功");
        varsMap.put("keyword3", "9");
        varsMap.put("keyword4", "2023-03-06 09:01:01");

        map.put("templateId", "15");//18603018431
        map.put("mobile", DESUtil.encode("18674842761", password));
        map.put("vars", JSON.toJSONString(varsMap));
        map.put("timestamp", System.currentTimeMillis() + "");
        map.put("signature", signature(map));

//        HttpRequest request = HttpRequest.post(productUrl).form(map);
        HttpRequest request = HttpRequest.post(productUrl)
                .contentType("application/json", "UTF-8").send(JSON.toJSONString(map));
        String result = new String(request.bytes(), Charset.forName("UTF-8"));

        System.out.println(JSON.toJSONString(map) + "\n" + result);
    }


    /**
     * 订购失败的模板消息
     * @throws Exception
     */
    @Test
    public void orderFailureTemplate() throws Exception {
        Map<String, Object> map = new HashMap<>();

        // keyword1|usermob,keyword2|ordertime,keyword3|productname,keyword4|orderstatus,keyword5|remark
        Map<String, Object> varsMap = new HashMap<>();
        varsMap.put("keyword1", "17610768237"); //usermob
        varsMap.put("keyword2", "2023-03-06 09:01:01"); //ordertime
        varsMap.put("keyword3", "快手定向流量5G加油包");//productname
        varsMap.put("keyword4", "失败");//orderstatus
        varsMap.put("keyword5", "");//remark

        map.put("templateId", "14");//18603018431
        map.put("mobile", DESUtil.encode("18674842761", password));
        map.put("vars", JSON.toJSONString(varsMap));
        map.put("timestamp", System.currentTimeMillis() + "");
        map.put("signature", signature(map));

//        HttpRequest request = HttpRequest.post(productUrl).form(map);
        HttpRequest request = HttpRequest.post(productUrl)
                .contentType("application/json", "UTF-8").send(JSON.toJSONString(map));
        String result = new String(request.bytes(), Charset.forName("UTF-8"));

        System.out.println(JSON.toJSONString(map) + "\n" + result);
    }

    private static String signature(Map<String, Object> map) {

        // 签名生成方式：signature= MD5(mobile&templateId&timestamp&passward)。
        StringBuilder origin = new StringBuilder();
        origin.append(map.get("mobile").toString())
                .append("").append(map.get("templateId").toString())
                .append("").append(map.get("timestamp").toString())
                .append("").append(password);

        return MD5.MD5Encode(origin.toString());

    }

}
