package com.chinacreator.order.test;


import java.net.InetAddress;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.Map.Entry;

import com.alibaba.fastjson.JSON;
import net.sf.json.JSONObject;

import org.junit.Test;
import org.junit.runner.RunWith;

import com.chinacreator.access.bean.FesMessage;
import com.chinacreator.access.dao.MessageDao;
import com.chinacreator.access.service.DxService;
import com.chinacreator.access.service.PartService;
import com.chinacreator.access.util.TransUtil;
import com.chinacreator.order.bean.SendBean;
import com.chinacreator.order.bean.SmsBean;
import com.chinacreator.order.dao.imp.QueryDaoImp;
import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.service.imp.OrderServiceImp;
import com.chinacreator.order.util.AESUtil;
import com.chinacreator.order.util.Util;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;


//@RunWith(SpringJUnit4ClassRunner.class)  //使用junit4进行测试
//@ContextConfiguration({"/spring/*.xml"})
/**
 *
 * @author Yk
 *
 */
public class JunitTest  {

    @Autowired
    private PartService partService;
    @Autowired
    private DxService dxService;

    JSONObject data = new JSONObject();
    JSONObject redata = new JSONObject();
    //@Test
    public void Test1() {//测试获取活动组信息
    	ArrayList<FesMessage> fes;
		try {
			fes = partService.getAllFesMessage();
			for (FesMessage fesMessage : fes) {
				System.out.println(fesMessage.toString());
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

    }

    //@Test
    public void Test2() {//测试时间比较器
    	DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
    	Date stime;
    	Date etime;
    	int sta = 0;
		try {
			stime = dateFormat.parse("2018-06-01");
			etime = dateFormat.parse("2018-06-30");
			sta = Util.copTime(stime, etime);
		} catch (ParseException e1) {
			System.out.println(e1);
			e1.printStackTrace();
		}
		System.out.println(sta);
    }

    /**
     * 测试AES加密与解密
     * AESUtil
     * AESUtil.encrypt 加密
     * AESUtil.decrypt 解密
     */
    //@Test
    public void Test3(){
    	String fes = "";
		try {
			fes = AESUtil.encrypt("cpid=2017060802&productid=2017060800064876",Util.geturlkeyWord());
		} catch (Exception e) {
			System.out.println("加密失败");
			e.printStackTrace();
		}
			System.out.println(fes);
		try {
			String cpid = Util.fogdec(fes, "cpid");
			String productid = Util.fogdec(fes, "productid");
			System.out.println("cpid : "+cpid+"   --    productid : "+productid);
			fes = AESUtil.decrypt(fes, Util.geturlkeyWord());
		} catch (Exception e) {
			System.out.println("解密失败");
			e.printStackTrace();
		}
			System.out.println(fes);
    }

    /**
     * 测试应用服务层取出活动组信息
     * PartService
     * PartService.fesExists
     */
    //@Test
    public void Test4(){//测试判断活动组是否存在
    	try {
			FesMessage fes = partService.fesExists("100003", 33);
			if(fes!=null){
				System.out.println(fes.toString());
			}else{
				System.out.println("未取出数据");
			}
		} catch (SQLException | ParseException e) {
			System.out.println("sql异常");
			e.printStackTrace();
		}
    }

    //@Test
    public void test5(){
    	String number = "53";
    	String number2 =  Util._N_to_10(number, 32);
    	System.out.println("32:"+number2);
        String num = "53";
    	String number3 = Util._10_to_N(num, 32);
    	System.out.println("10:"+number3);
    }
    //@Test
    public void test6(){ //测试工具类
    	JSONObject data = new JSONObject();
    	data.put("fes", "9oi");//10001
    	data.put("sou", "1k"); //51
    	JSONObject reqjson =  partService.pageStyle(data);
    	System.out.println(reqjson.toString());
    }
    //@Test
    public void test7(){
    	OrderServiceImp s = new OrderServiceImp();
    	JSONObject data = new JSONObject();
    	data.put("usermob", "13113058549");
    	data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f5f7bae7134a9f80704eb805a47704037");
    	data = s.orderQuery(data);
    	System.out.println(data.toString());
    }

    //@Test
    public void test8(){
    	QueryDaoImp dao = new QueryDaoImp();
    	HttpSendService send = new HttpSendServicImp();
    	SendBean sbean = new SendBean();
    	JSONObject data = new JSONObject();
    	data.put("usermob", "18515955325");
    	data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f5f7bae7134a9f80704eb805a47704037");
    	data.put("fes", "9oh");
		SmsBean sms = new SmsBean();
		sbean.setCpid(Util.fogdec(data.getString("fog"), "cpid"));
		sms.setBusiid("sms");
		sms.setUsermob(data.getString("usermob"));
		try {
			sms.setSmstype(dao.querySms(Util._N_to_10((String)data.get("fes"), 32),Util.fogdec(data.getString("fog"), "cpid"),Util.fogdec(data.getString("fog"), "productid"),0));
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		sms.setSmscontent("");
		JSONObject smsJson = JSONObject.fromObject(sms);
		try {
			sbean.setData(smsJson);
		} catch (Exception e) {
			e.printStackTrace();
		}
		JSONObject reJson = send.sendPost("http://61.50.245.146:8050/directional/initUnicom.do",JSONObject.fromObject(sbean));
		System.out.println(reJson.toString());
    }

    //@Test
    public  void test9(){
    	JSONObject data = new JSONObject();
    	data.put("fes", "9ok");
    	data.put("usermob", "18515955325");
    	System.out.println(partService.award(data).toString());
    }


    //@Test
    public  void test10(){
    	JSONObject data = new JSONObject();
    	data.put("usermob", "18684984095");
    	data.put("content", "测试奖券号码!");
    	System.out.println(partService.sendVerCode(data).toString());
    }

    //@Test
    public  void test11(){
    	String usermob = "18515955325";
    	String fes = "10004";
    	JSONObject data = partService.queryPrizeMass(usermob, fes);
    	System.out.println("date"+ data);
    }

    //@Test
    public void test13(){
    	JSONObject data = new JSONObject();
    	data.put("usermob", "18684692749");
    	//df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d
    	//df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f13ecd73d7d90b1260898eebafbdac422


    	data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f13ecd73d7d90b1260898eebafbdac422");
    	data.put("code", "");
    	data.put("fes","9ol");
    	data.put("sou","33");
    	data.put("useraccount", "");
    	JSONObject c = new JSONObject();
    	try {
    		c = dxService.submitSc(data, 0);
		} catch (Exception e) {
			System.out.println("失败");
			e.printStackTrace();
		}
    	System.out.println(c.toString());
    }

    /**
     * 加密cpid 与  productid
     */
    //@Test
	public void test_01() {
		String c = new String();
		String key = "acit0Mnetunic0m6";
		try {
			c = AESUtil.encrypt("cpid=2017060800064876&productid=2018072301",
					key);
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println(c);
		String m = new String();
		try {
			m = AESUtil.decrypt(c, key);
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println(m);
	}

    /**
     * 测试同步信息包装
     */
    //@Test
    public void test_02(){
	   JSONObject data = new JSONObject();
   	   data.put("usermob", "17600113926");
   	   data.put("productid", "2017060804");//9元
   	   data.put("useraccount", " 58294969780");
   	   data.put("sou", "33");
   	   data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f13ecd73d7d90b1260898eebafbdac422");
   	   try {
   		redata = dxService.activateSc(data, 1);
   	   } catch (Exception e2) {
		e2.printStackTrace();
   	   }
	   System.out.println(redata.toString());
    }

   //@Test
   public void test_03(){
	   JSONObject data = new JSONObject();
  	   data.put("device_id", "53219619575");

  	   try {
  		redata = dxService.devToPhone(data);
  	   } catch (Exception e2) {
		e2.printStackTrace();
  	   }
	   System.out.println(redata.toString());
   }


   /**
 *
 */
   //@Test
   public void test_04(){
	   JSONObject data = new JSONObject();
  	   data.put("usermob", "13161003276");
  	   data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f13ecd73d7d90b1260898eebafbdac422");
  	   try {
  		redata = dxService.cpidAndPhoneToFolw(data);
  	   } catch (Exception e2) {
		e2.printStackTrace();
  	   }
	   System.out.println(redata.toString());
   }



/**
 * 加密cpid 与  productid
 * @throws Exception
 */
//@Test
public void test_05() throws Exception {
	String fog = "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f13ecd73d7d90b1260898eebafbdac422";
	String productid = "2017060802";
	String str = Util.fogret(fog,productid);
	System.out.println(str);
}

//@Test
public void test_06() throws Exception{
	data.put("usermob", "");
	data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d");
	data.put("useraccount", "38706368392");
	data.put("sou", "33");
	redata = dxService.yuyueSc(data);
	System.out.println(redata.toString());
}

//@Test
public void test_07() throws Exception{
		data.put("usermob", "");
		data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d");
		data.put("useraccount", "39078429846");
		data.put("sou", "33");
		data.put("fes", "9om");
		redata = dxService.yuyueSc(data);
		System.out.println("返回结果"+redata.toString());
	}

	//@Test
	public void test_08() throws Exception{
		data.put("usermob", "");
		data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d");
		data.put("useraccount", "53944176633");
		data.put("sou", "33");
		data.put("fes", "9om");
		redata =  dxService.activateSc(data, 0);
		System.out.println("返回结果"+redata.toString());
	}

	//@Test
	public void test_09()throws Exception{
		InetAddress add = InetAddress.getLocalHost();
		String host = add.getHostAddress();
		System.out.println(host);
		Timestamp c = Util.beforeDate(0);
		System.out.println(c);

	}
	//@Test//短信发送
	public void test_10()throws Exception{
		HttpSendServicImp send = new HttpSendServicImp();
		String requestUrl = Util.getsendUrl();
		SmsBean sms = new SmsBean();
		sms.setBusiid("sms");
		//根据fog与fes值获取tb_ordercenter_product表中值
		sms.setSmstype("906");
		sms.setUsermob("18515955325");
		sms.setSmscontent("");
		JSONObject smsJson = JSONObject.fromObject(sms);
		SendBean sbean = new SendBean();
		sbean.setCpid("2017060800064876");
		sbean.setData(smsJson);
		System.out.println(send.sendPost(requestUrl,JSONObject.fromObject(sbean)).toString());
	}
	//@Test
	public void test_11()throws Exception{
		dxService.taskYuyue();
	}

	//@Test
	public void test_12()throws Exception{
		String co = "73";
		if(co.equals("70")||co.equals("71")){
			System.out.println("满足");
		}else{
			System.out.println("不满足");
		}
	}

	//@Test //解密
	public void test_13()throws Exception{
		String d =
				"5f794d493d2286c6812ba8502c9d9782699f368bdaf09ea14de330efe92e042ab4979643e36e6dfe5253bcb01f110c30cf0978f4fc83d06beb3839d4c3ca26b7341940a9084244557dbc09e21f6b02b12539a123c55185b7ce613bee409afdf45ff6a1838ca5068448301483abeb998a";
		String key = "M0M0#$!keymomo91";
		String out = AESUtil.decrypt(d, key);
		System.out.println(out);
	}

	//@Test
	public void test_14()throws Exception{
		Timestamp  time = Util.beforeDate(1);
		System.out.println(time.toString());
	}

	//@Test
	public void test_15()throws Exception{
		QueryDaoImp dao = new QueryDaoImp();
		int c = dao.intcodeLim("18515955325", "11111", "1111");
		System.out.println(c);

	}

	//同步
	//@Test
	public void test_16()throws Exception{
		JSONObject data = new JSONObject();
		data.put("usermob", "15607224529");
		data.put("useraccount", "2718897575");
		data.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f8a6b9a208b148850e52010b01c346fa35f0d16d233bd8bb10a1367b0bd2122fb");
		data.put("sou", "29");
		String key = "Toutiao1@Unicom!";
		String arg = AESUtil.encrypt(Util.retactivateJsonString(data,0), key);
		String  ret = TransUtil.postc(Util.getTtSyncUrl(),arg);
		JSONObject fond = JSONObject.fromObject(ret);
		System.out.println(fond.toString());
	}

	//激活
	//@Test
	public void test_jihuo()throws Exception{
		JSONObject jihuo = new JSONObject();
		jihuo.put("code", "311541");
		jihuo.put("fog", "df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3f8a6b9a208b148850e52010b01c346fa35f0d16d233bd8bb10a1367b0bd2122fb");
		jihuo.put("usermob", "18515955325");
		jihuo.put("useraccount", "36951009731");
		jihuo.put("fes", "9om");
		jihuo.put("sou", "29");
		JSONObject c = dxService.activateSc(jihuo, 2);
		System.out.println(c.toString());
	}

	public static HttpSendService send = new HttpSendServicImp();
	//@Test
	public void test_17()throws Exception{
		JSONObject data = new JSONObject();
		data.put("usermob", "15669003573");
		data.put("useraccount", "");
		data.put("fog", "1be32dd23eda5ed689b4b4a24665dde3bc905780ae9e7ebfafe6d6ec643813117fd192eb351486fb56805cffb002078dec857ed462593527d9bbce7c2fcc0aa4");
		data.put("sou", "0");
		send.sendPost("http://127.0.3.5:8050/directional/initUnicom.do", JSONObject.fromObject(Util.retOrderBean(data,1)));

		//http://127.0.10.3:8050/directional/initUnicom.do
		//{"busiid":"cancel","cancelchannel":"0","usermob":"18525756120","productid":"2016090102","useraccount":""}
	}

	//@Test
	public void test_18()throws Exception{
		//int i = 0;//同步
		//int i = 1;//退订
		//int i = 2;//激活

//		JSONObject data = new JSONObject();
//		data.put("usermob", "18515955325");
//		data.put("useraccount", "test190820");
//		data.put("sid", "201905091449560000011");
//		//String arg = retactivateJsonString(data, i);
//		//dxService.activateSc(data, i);
//		String url = Util.getWySyncUrl();
//		String key = Util.getkeyMap("2019042259387282");
//		String arg = retactivateJsonString(data,i,key);//加密
//		System.out.println("同步地址："+url);
//		System.out.println("加密后数据："+arg);
		//String ret = TransUtil.post(url,arg);
		//System.out.println("返回结果："+ret);


		JSONObject jihuo = new JSONObject();
		jihuo.put("code", "311541");
		jihuo.put("fog", "b5d89178758996a6506b0db57d3978598be14debbffaf7bfd6b11836759f0250f34507ab2c63fbad208f6bea637cdc98");
		jihuo.put("usermob", "17633754496");
		jihuo.put("useraccount", "5cf7362fa3b4ae4e428a11a2");
		jihuo.put("fes", "9ot");
		jihuo.put("sou", "16");
		JSONObject c = dxService.activateSc(jihuo, 2);
		System.out.println(c.toString());



	}

	/**
	 * 1.所有参与传参的参数按照accsii排序（升序）
	 * 2.空值不传递，不参与签名组串
	 * 3.排序后结果加上key=key（参数）
	 * 与常用Sign有区别。
	 * @param characterEncoding
	 * @param parameters
	 * @param key
	 * @return
	 */
	public static String createSign(String characterEncoding,SortedMap<String,String> parameters,String key){
        StringBuffer sb = new StringBuffer();
        StringBuffer sbkey = new StringBuffer();
        Set<Entry<String, String>> es = parameters.entrySet();//所有参与传参的参数按照accsii排序（升序）
        Iterator<Entry<String, String>> it = es.iterator();
        while(it.hasNext()) {
            Map.Entry<String, String> entry = (Map.Entry<String, String>)it.next();
            String k = (String)entry.getKey();
            Object v = entry.getValue();
            //空值不传递，不参与签名组串
            if(null != v && !"".equals(v)) {
                sb.append(k + v);
                sbkey.append(k + v);
            }
        }
        sbkey=sbkey.append("key="+key);
        System.out.println("加密的字符串："+sbkey);
        //MD5加密,结果转换为大写字符
        String sign = "";
		try {//加密
			sign = AESUtil.encrypt(sbkey.toString(), key);
		} catch (Exception e) {
			e.printStackTrace();
		}
        return sign;
    }

	static String characterEncoding = "UTF-8";
	public static String retactivateJsonString(JSONObject data,int i,String key) throws Exception{
		JSONObject json = new JSONObject();
		SortedMap<String, String> parameters = new TreeMap<String, String>();
		json.put("sid", data.getString("sid"));
		parameters.put("sid",data.getString("sid"));

		json.put("usermob", data.getString("usermob"));
		parameters.put("usermob", data.getString("usermob"));

		json.put("productid","");
		parameters.put("productid", "");

		json.put("useraccount", data.getString("useraccount"));
		parameters.put("useraccount", data.getString("useraccount"));

		json.put("curstatus", i);//状态
		parameters.put("curstatus", Integer.valueOf(i).toString());

		if(i==0){//同步
			json.put("ordertime", Util.getDate());
			parameters.put("ordertime", Util.getDate());

			json.put("canceltime", "");
		}
		if(i==1){//退订
			json.put("ordertime", "");

			json.put("canceltime", Util.getDate());
			parameters.put("canceltime", Util.getDate());
		}
		if(i==2){//号码激活不存在订购时间与退订时间
			json.put("ordertime", "");
			json.put("canceltime","");
		}
		json.put("channel", "99");
		parameters.put("channel", "99");
		json.put("sign",createSign(characterEncoding, parameters, key));
		System.out.println(json.toString());
		return json.toString();
	}

	@Autowired
	private MessageDao messagedao;

	//@Test
	public void test_19()throws Exception{//原有unorder接口
		String sql = "UPDATE td_directed_order SET useraccount = ? WHERE cpid = ? AND productid = ? AND usermob = ?";
		ArrayList<Object> para = new ArrayList<Object>();
		para.add("test13200");
		para.add("2019041258907256");
		para.add("2019041201");
		para.add("18515955325");
		messagedao.booleanUid(sql, para);
	}



	//@Test
	public void test_20() throws Exception {
		//{"code":"762101","fog":"df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d","usermob":"15542639423","useraccount":"b246ad51a2b6e43cc8f85bb40b34","fes":"9om","sou":"29"}

		//String json = "{\"code\":\"762101\",\"fog\":\"df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d\",\"usermob\":\"15542639423\",\"useraccount\":\"b246ad51a2b6e43cc8f85bb40b34\",\"fes\":\"9om\",\"sou\":\"29\"}";
		//

		String json = "{\"code\":\"557778\",\"fog\":\"df3958be828815ec18613612fa1e7a55ec0c66c954ceccf62ada29431f927b3fc23dcc841e7e4f538b16a2506dd8dd5d\",\"usermob\":\"15530032190\",\"useraccount\":\"bee13e5cad848eaa85d004103562\",\"fes\":\"9om\",\"sou\":\"29\"}";

		JSONObject jsonObject = JSONObject.fromObject(json);
		dxService.activateSc(jsonObject, 2);


	}

}
