package com.chinacreator.order.test;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.poifs.filesystem.OfficeXmlFileException;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.junit.Test;

import net.sf.json.JSONObject;

import com.chinacreator.order.send.HttpSendService;
import com.chinacreator.order.send.imp.HttpSendServicImp;
import com.chinacreator.order.util.DesUtilTo32;

public class SmsCont {

	HttpSendService send = new HttpSendServicImp();

	String requestUrl = "http://127.0.4.1:9090/sms";
	String sendsms = "sendsms";
	String spcode = "106555064";
	String SPNumber = "106555064";
	String ReportFlag = "1";
	String tu0W1lPd = "12345678";
	//读取的xlsx文件位子
	String excelName = "E:/phon01.xlsx";

	String okTxtName = "E:/ok.txt"; //订购成功号码日志
	String noTxtName = "E:/no.txt";	//订购失败号码日志

	String smsContent = "尊敬的用户您好，8月1日您在学习强国APP兑换的学习强国定向流量包已到账，无需重复兑换。由于月初系统延迟导致学习强国提示您兑换失败，我们深表歉意，此次点点通将不被扣除，流量使用情况可登录中国联通APP查询，感谢您的理解与支持！";
	String num = "201908031522";
	//@Test
	public void test_01(){

//		getPhonList(excelName);
		fileChaseFW(okTxtName, "--------------S-"+num+"-S--------------");
		fileChaseFW(noTxtName, "--------------S-"+num+"-S--------------");
		//发送
		SendSms(excelName,smsContent);
		fileChaseFW(okTxtName, "--------------E-"+num+"-E--------------");
		fileChaseFW(noTxtName, "--------------E-"+num+"-E--------------");
	}

	public void SendSms(String excelName,String smsContent) {
		ArrayList<String> phon = getPhonList(excelName);//获取需要发送的手机号
		ArrayList<String> nophon = new ArrayList<String>();//失败的手机号
		for (String string : phon) {
				String con = "";
				JSONObject json = new JSONObject();
				json.put("busiid", sendsms);
				json.put("spcode", spcode);
				JSONObject content = new JSONObject();
				content.put("SPNumber", SPNumber);
				content.put("UserNumber", string);
				content.put("ReportFlag", ReportFlag);
				content.put("MessageContent",smsContent);
			try {
				con = DesUtilTo32.encode(content.toString(), tu0W1lPd);
			} catch (Exception e) {
				e.printStackTrace();
			}
				json.put("content", con);
				System.out.println("-----------------------------------");
				JSONObject re = send.sendPost(requestUrl, json);
				System.out.println("发送信息："+json.toString());
				re.remove("SequenceNumber");
				System.out.println("返回结果："+re.toString());
				System.out.println("-----------------------------------");
			if(!re.getString("resultcode").equals("0")){
				nophon.add("号码："+string+"  失败原因："+re.getString("resultinfo"));
				nophon.add(string);
				fileChaseFW(noTxtName, string);
			}
			if(re.getString("resultcode").equals("0")){
				System.out.println("成功号码"+string);
				fileChaseFW(okTxtName, string);
			}
		}
		System.out.println("|-----------发送失败号码STA--------------|");
		for (String reephon : nophon) {
			System.out.println(reephon);
		}
		System.out.println("|-----------发送失败号码END--------------|");
			System.out.println("失败号码数量："+nophon.size());
		//失败号码需要存储
	}

	/**
	 * 获取列表 读取xls
	 * @param excelName
	 * @return
	 */
	public ArrayList<String> getPhonList(String excelName){
		Workbook workbook = null;
		Sheet sheet = null;
		Row row = null;
		Cell cell = null;
		ArrayList<String> phonlist = new ArrayList<String>();
		try {
			workbook = new HSSFWorkbook(new FileInputStream(excelName));
		} catch (OfficeXmlFileException e) {
			try {
			workbook = new XSSFWorkbook(new FileInputStream(excelName));
			} catch (Exception e2) {
				System.out.println("XSSFWorkbook异常");
			}
		} catch (Exception e) {
			System.out.println("HSSFWorkbook异常");
		}
		if(workbook == null){
			throw new IllegalArgumentException("ecxel文件获取失败");
		}
		sheet = workbook.getSheetAt(0);// 获取第一个页签
		if(sheet == null){
			throw new IllegalArgumentException("为正确的获取ecxel的sheet");
		}
		int LastRowNum =  sheet.getLastRowNum();//获取总行数
		int toNum = 0;
		for (int rowNum = 1; rowNum <= LastRowNum; rowNum++) {
			toNum++;
			row = sheet.getRow(rowNum);// 获取页签的第rowNum行
			if(row!=null){
				row.getCell(0).setCellType(Cell.CELL_TYPE_STRING);//先设置Cell的类型，然后就可以把纯数字作为String类型读进来了：
				cell = row.getCell(0);
				String phon = cell.getStringCellValue();//获取String类型的单元格的值
				phonlist.add(phon);
				System.out.println("|-----------------------------------------|");
				System.out.println("当前读取号码："+phon);
				System.out.println("总数："+LastRowNum);
				System.out.println("当前读取条数："+toNum);
				int omNum =  LastRowNum-toNum;
				System.out.println("当前剩余条数:"+omNum);
				System.out.println("|-----------------------------------------|");
			}
		}
		System.out.println("|----------------读取完毕--------------------|");
		return phonlist;
	}


	/**
     * 写入TXT文件
     */
    public static void writeFile(String txtName,String phon) {
        try {
            File writeName = new File(txtName); // 相对路径，如果没有则要建立一个新的output.txt文件
            //writeName.createNewFile(); //创建新文件,有同名的文件的话直接覆盖
            try (FileWriter writer = new FileWriter(writeName);
                 BufferedWriter out = new BufferedWriter(writer)
            ) {
                out.write(phon+"\r\n"); // \r\n即为换行
                out.flush(); // 把缓存区内容压入文件
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public static void fileChaseFW(String filePath, String phone) {

        try {
            //构造函数中的第二个参数true表示以追加形式写文件
            FileWriter fw = new FileWriter(filePath,true);
            fw.write(phone+"\r\n");
            fw.close();
        } catch (IOException e) {
            System.out.println("文件写入失败！" + e);
        }
    }



	//@Test
	public void test_02(){
		//发送
		SendSms(excelName,smsContent);
		ArrayList<String> phon = getPhonList(excelName);
		for (String string : phon) {
			fileChaseFW(okTxtName, string);
		}
		for (String string : phon) {
			fileChaseFW(noTxtName, string);
		}

	}

}
